#ifndef DLGPREVIEW_H
#define DLGPREVIEW_H

#include "common.h"
#include "pane.h"
#include "xstate.h"

#include <X11/Xlib.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/ScrollBar.h>


extern void close_dialog(Widget w, XtPointer client, XtPointer call);
extern void GoToNext(Widget w, XtPointer cli, XtPointer call);
extern void GoToPrev(Widget w, XtPointer cli, XtPointer call);
extern long GetNumStates();

class dlgPreview {

 public:
  dlgPreview(Widget toplevel, Colormap *cmap, GC *gc, bool isInit, Pane *fir, Pane *las, bool show, XState *firSt);
  ~dlgPreview();

  Display  *gpDisplay;
  GC       *gpGC;

  Pane *firstPane, *curPane, *lastPane;

  Widget dialog, previewPane, pdpane;

  XColor selected, unselected;

  void NewPane(XState *state, bool showIt);
  void DumpIDs();
  void RefreshAllPanes(XState *first, bool create, bool generate);
  void RemovePane(Pane *pane, bool isShown, XState *firSt);
  void SelectPane(Pane *target);
  void SetBackground(Pane *target);

};

#endif
