/*
*  David Eyerman
*  davideyerman@hotmail.com
*  EyeFract 0.6.0
*/

#include "eyefract.h"





// 
//
//  expose and resize events
//
//
////////////////////////////////////////////////////////////////////
void redraw(Widget w, XtPointer client, XEvent *event){
  if (curState->pix) {
    XCopyArea(gpDisplay, curState->pix, XtWindow(daCanvas), gGC, 0, 0, curState->lWidth, curState->lHeight, 0, 0);
  }

}





//
//
//  Tests
//
//
///////////////////////////////////////////////////////////////////////
bool isValueOK(char *value, const char *name)
{
  unsigned int i;

  for (i=0; i<strlen(value); i++){
    if ( isalpha(value[i]) ) 
      {
      printf("ERROR: Invalid parameter: %s\n", name);
      return false;
      }
  }

  return true;
}


bool TestAndSetValues(long *tempi, long *w, long *h){
    /*  tests the text boxes of number of iterations,
     *  width and height to see if we have valid numbers */
    char   *t="";
    bool ok=true;

    XtVaGetValues(itersBox, XmNvalue, &t, NULL);
    if ((ok = ok && isValueOK(t, "number of iterations")) )
      *tempi = atoi(t);

    XtVaGetValues(widthBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, "width")) )
      *w=atoi(t);

    XtVaGetValues(heightBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, "height")) )
      *h=atoi(t);

    if ( ok && (*tempi<=0) ) {
      printf("ERROR: The number of iterations must be positive\n");
      ok=false;
    }

    /*  returns 1 if every test passed  */
    return ok;
}


bool TestUseColor()
{
  bool useColor;

  XtVaGetValues(XtNameToWidget(typeMenu, "button_2"), XmNset, &useColor, NULL);

  return useColor;
}







void close_dialog(Widget w, XtPointer client, XtPointer call) {
  Widget which = (Widget) client;

  if (aboutDialog)
    if (which==aboutDialog->dialog)
      {
      delete aboutDialog;   aboutDialog = 0;
      }

  if (previewDialog)
    if (which==previewDialog->dialog)
      {
      delete previewDialog;   previewDialog = 0;

      if ((which=XtNameToWidget(viewMenu, "button_2")))
	XtVaSetValues(which, XmNset, false, NULL);
      }

  if (which==colorDialog)
    {
    if ((which=XtNameToWidget(viewMenu, "button_1")))
      XtVaSetValues(which, XmNset, false, NULL);
    XtUnmanageChild(colorDialog);
    }
  else if (which==paramDialog)
    {

    if ((which=XtNameToWidget(viewMenu, "button_0")))
      XtVaSetValues(which, XmNset, false, NULL);
    XtUnmanageChild(paramDialog);
    }
  else if (which==newColormapDialog)
      XtUnmanageChild(newColormapDialog);
}








//
//
//  Controlling the "Abort" dialog during generation
//
//////////////////////////////////////////////////////////
/*
void stop(Widget dialog, XtPointer client, XtPointer call){
  //  set a flag that the user wants to abort the generation, if we can abort

    short itype = (int) client;

    stopped=true;
    if ((curState->next==curState) && (itype==CF_NORMAL)) stopped=false;
}

void TimeoutCursors(bool on, bool interruptable, int type){

    //  called at start of fractal generation/color change.
    //  this will present the "working" dialog, and will change the mouse
    //  cursors to their appropriate values.
     
    XEvent        event;
    XmString      str;
    static short  locked;
    static Cursor cursor;
    XSetWindowAttributes attrs;

    if (on)
        locked++;
    else
        locked--;
    if ((locked>1) || (locked==1 && on==0))
        return;

    stopped = false;
    if (!cursor)
        cursor = XCreateFontCursor(gpDisplay, XC_watch);

    attrs.cursor = on? cursor : None;
    XChangeWindowAttributes(gpDisplay, XtWindow(topLevel), CWCursor, &attrs);
    if (paramDialog)
        XChangeWindowAttributes(gpDisplay, XtWindow(paramDialog), CWCursor, &attrs);
    if (colorDialog)
        XChangeWindowAttributes(gpDisplay, XtWindow(colorDialog), CWCursor, &attrs);
    if (previewDialog)
        XChangeWindowAttributes(gpDisplay, XtWindow(previewDialog->dialog), CWCursor, &attrs);
    XFlush(gpDisplay);
    if (on) {
        waitDialog = XmCreateWorkingDialog(topLevel, "Working", NULL, 0);
	XtUnmanageChild((Widget) XmMessageBoxGetChild(waitDialog, XmDIALOG_OK_BUTTON));
	XtUnmanageChild((Widget) XmMessageBoxGetChild(waitDialog, XmDIALOG_HELP_BUTTON));

	if (interruptable){
	    str = XmStringCreateLocalized("Abort");
	    XtVaSetValues(waitDialog, XmNcancelLabelString, str, NULL);
	    XmStringFree(str);
	    XtAddCallback(waitDialog, XmNcancelCallback, stop, (XtPointer) type);
	}
	else
    	    XtUnmanageChild(XmMessageBoxGetChild(waitDialog, XmDIALOG_CANCEL_BUTTON));

	XtManageChild(waitDialog);
    }
    else {
        while (XCheckMaskEvent(gpDisplay, ButtonPressMask | ButtonReleaseMask |
	    ButtonMotionMask | PointerMotionMask | KeyPressMask | LeaveWindowMask, &event)) { }

	XtDestroyWidget(waitDialog);
    }

}

bool CheckForInterrupt(){
    //  if event happened in working dialog, dispatch it.
    //  if not, ignore it
    XEvent event;

    XFlush(gpDisplay);
    XmUpdateDisplay(topLevel);

    while (XCheckMaskEvent(gpDisplay, ButtonPressMask | ButtonReleaseMask |
	ButtonMotionMask | PointerMotionMask | KeyPressMask | LeaveWindowMask, &event)) {

      if ((event.xany.window = XtWindow(waitDialog) ) )
	XtDispatchEvent(&event);

    }

    return stopped;
}
*/



void SetMessageBarCoords(double a, double b, double c, double d, short howManyPairs){
    /*  sets the status bar message to the coordinates (a,b) [ -> (c,d) ]  */
    char      buf[24];
    XmString  mess, pair2;

    /*  display (x, y) pair in status bar  */
    XtVaGetValues(messageBar, XmNlabelString, &mess, NULL);
    XtVaGetValues(messageBar, XmNlabelString, &pair2, NULL);
    sprintf(buf, "%.8f", a);
    mess = XmStringConcat(sOpenPar, XmStringCreateLocalized(buf));
    mess = XmStringConcat(mess, sComma);
    sprintf(buf, "%.8f", b);
    mess = XmStringConcat(mess, XmStringCreateLocalized(buf));
    mess = XmStringConcat(mess, sClosePar);

    /*  if 2 pairs of coords given, display them as:
     *  (a, b) -> (c, d)  */
    if (howManyPairs==2){
        pair2 = XmStringConcat(XmStringCreateLocalized(" -> "), sOpenPar);
        sprintf(buf, "%.8f", c);
        pair2 = XmStringConcat(pair2, XmStringCreateLocalized(buf));
        pair2 = XmStringConcat(pair2, sComma);
        sprintf(buf, "%.8f", d);
        pair2 = XmStringConcat(pair2, XmStringCreateLocalized(buf));
        pair2 = XmStringConcat(pair2, sClosePar);
        mess = XmStringConcat(mess, pair2);
    }

    XtVaSetValues(messageBar, XmNlabelString, mess, NULL);

    XmStringFree(mess);
    XmStringFree(pair2);
}








void create_popupmenu(){
    Widget widget;

    if (popupmenu) {
      XtUnmanageChild(popupmenu);
      XtDestroyWidget(popupmenu);
    }
  
    popupmenu = XmCreatePopupMenu(daCanvas, "State Popup", NULL, 0);
    XtVaSetValues(popupmenu, XmNautoUnmanage, true, NULL);

    if (curState->next != curState) {
      widget = XtVaCreateManagedWidget("Next", xmPushButtonWidgetClass, popupmenu,
				       XmNmnemonic,   'N',
				       NULL);
      XtAddCallback(widget, XmNactivateCallback, GoToNext, NULL);
      widget = XtVaCreateManagedWidget("Previous", xmPushButtonWidgetClass, popupmenu,
				       XmNmnemonic,   'P',
				       NULL);
      XtAddCallback(widget, XmNactivateCallback, GoToPrev, NULL);

      widget = XtVaCreateManagedWidget("Delete", xmPushButtonWidgetClass, popupmenu,
				       XmNmnemonic,    'D',
				       NULL);
      XtAddCallback(widget, XmNactivateCallback, DeleteState, NULL);

      XtVaCreateManagedWidget(" ", xmSeparatorWidgetClass, popupmenu, NULL);

    }


    widget = XtVaCreateManagedWidget("Zoom in", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   'i',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_ZOOMIN);
    widget = XtVaCreateManagedWidget("Zoom out", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   'o',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_ZOOMOUT);
    widget = XtVaCreateManagedWidget("Re-center image", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   'R',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_RECENTER);
    widget = XtVaCreateManagedWidget("Re-scale image", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   's',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_RESCALE_FROMCENTER);
    widget = XtVaCreateManagedWidget("Re-scale and Re-center", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   'a',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_RESCALE_FROMHERE);

    XtVaCreateManagedWidget(" ", xmSeparatorWidgetClass, popupmenu, NULL);

    widget = XtVaCreateManagedWidget("Change Colors", xmPushButtonWidgetClass, popupmenu,
                            XmNmnemonic,   'C',
                            NULL);
    XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_CHANGECOLORS);

    if (curState->type==MANDELBROT) {
      widget = XtVaCreateManagedWidget("Create Julia", xmPushButtonWidgetClass, popupmenu,
				       XmNmnemonic,   'J',
				       NULL);
      XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_JULIA);
    } else {
      widget = XtVaCreateManagedWidget("Go to Mandel coords", xmPushButtonWidgetClass, popupmenu,
				       XmNmnemonic,   'M',
				       NULL);
      XtAddCallback(widget, XmNactivateCallback, PopupMenuSelect, (XtPointer) DO_MANDELBROT);
    }
}



void mouseEvent(Widget w, XtPointer client, XEvent *event){
    /* function for handling all mouse input events */
    static long      x, y, last_x, last_y;
    short            type=(int) client;
    static short     button=-1;
    static double    tx, ty, ux, uy;
    char             buf[32];

    if (type == DOWN){
        /* mouse pressed event
         * do nothing, just store coordinates and figure out which button was pressed
         */
        x = event->xbutton.x;
        y = event->xbutton.y;
        last_x = event->xbutton.x;
        last_y = event->xbutton.y;
        if (event->xbutton.button == Button1) button = 1;
        if (event->xbutton.button == Button3) button = 2;
        if (event->xbutton.button == Button2) button = 3;

        /*  convert x and y to cartesian coordinates  */
        tx = curState->dXmin + (x * (curState->dXmax-curState->dXmin)) / curState->lWidth;
        ty = curState->dYmax - (y * (curState->dYmax-curState->dYmin)) / curState->lHeight;

    }
    else if ((type == MOTION) && (button==1)){
        /* draw a rectangle with dashed lines from where the
         * user first clicked to where the mouse pointer is now.
         * this selection will be the area to be zoomed in on once the
         * user stops dragging the mouse and releases the button
         */
        GC         gct;
        XGCValues  gcv;
        bool       isRatio;
        double     true_r, new_r;
        long       h, wd, new_x, new_y;

        new_x=event->xmotion.x;
        new_y=event->xmotion.y;

        XtVaGetValues(keepaspect, XmNset, &isRatio, NULL);
        if (isRatio) {
            true_r = (double) (curState->lWidth)/(curState->lHeight);

            wd = abs(new_x-x);
            h = abs(new_y-y);
            new_r = (double) wd/h;

            if (true_r==new_r){;}
            else {
                if (true_r>new_r){
                    wd = (long) (true_r*h);
                    new_x = (new_x<x)? x-wd : x+wd;
                }
                else{
                    h = (long) (wd/true_r);
                    new_y = (new_y<y)? y-h : y+h;
                }
            }
        }

        /*  update message bar with coordinates of box  */
        ux = curState->dXmin + (new_x * (curState->dXmax-curState->dXmin)) / curState->lWidth;
        uy = curState->dYmax - (new_y * (curState->dYmax-curState->dYmin)) / curState->lHeight;

        SetMessageBarCoords(tx, ty, ux, uy, 2);

        gct = XCreateGC(gpDisplay, XtWindow(w), 0, NULL);

        XSetLineAttributes(gpDisplay, gct, 1, LineOnOffDash, CapRound, JoinRound);

        /*  draw lines over previous lines with last_x, last_y
            draw new ones for xmotion.x and xmotion.y
    
            NOTE: XDrawRectangle is not used here in order to
            use the dotted lines   */
        gcv.foreground = whitepixel;
        XSetForeground(gpDisplay, gct, gcv.foreground);
        XSetFunction(gpDisplay, gct, GXxor);

        XDrawLine(gpDisplay, XtWindow(w), gct, x, y, last_x, y);
        XDrawLine(gpDisplay, XtWindow(w), gct, last_x, y, last_x, last_y);
        XDrawLine(gpDisplay, XtWindow(w), gct, last_x, last_y, x, last_y);
        XDrawLine(gpDisplay, XtWindow(w), gct, x, last_y, x, y);

        XDrawLine(gpDisplay, XtWindow(w), gct, x, y, new_x, y);
        XDrawLine(gpDisplay, XtWindow(w), gct, new_x, y, new_x, new_y);
        XDrawLine(gpDisplay, XtWindow(w), gct, new_x, new_y, x, new_y);
        XDrawLine(gpDisplay, XtWindow(w), gct, x, new_y, x, y);

        last_x = new_x;
        last_y = new_y;

        XFreeGC(gpDisplay, gct);

    } else if (type == MOTION) {
        /*  get x,y of mouse pointer, convert to cartesian  */
        ux = curState->dXmin + (event->xmotion.x * (curState->dXmax-curState->dXmin)) / curState->lWidth;
        uy = curState->dYmax - (event->xmotion.y * (curState->dYmax-curState->dYmin)) / curState->lHeight;

        /*  set message bar to coordinates of current mouse position  */
        SetMessageBarCoords(ux, uy, 0, 0, 1);

    } else if (type == OUT) {
      /*  mouse cursor left the drawing area, clear the message bar  */

        sprintf(buf, "EyeFract %s", VERSION);
        XtVaSetValues(messageBar, XmNlabelString, XmStringCreateLocalized(buf), NULL);

    } else if (type == UP){
        /* mouse button release event */

        /* if the user dragged the primary button, get the
         * coordinates of rectangle's edge and zoom in
         */

        if ((button==1) && (x!=last_x) && (y!=last_y)) {
             long     tempi, h, w, same=-1;

            /* check on number of iterations,
             * width and height typed values */
	     if (TestAndSetValues(&tempi, &w, &h)) {

		if ((curState->lWidth==w) && (curState->lHeight==h)) same=1;
                NewState(tx<ux? tx : ux,    tx<ux? ux : tx,
                         ty<uy? ty : uy,    ty<uy? uy : ty,
                         w,       h,        TestUseColor(),
                         tempi,             curState->type,
                         curState->function->parameter.a,  curState->function->parameter.b);

                /* zoom in.  create the fractal for the new coordinates  */
                CreateFractal(CF_NORMAL * same);
            }
        }
        else if (button>1)
	    {
	        /*  popup menu:  delete, change colors, <sep>,
		    zoom in, zoom out, re-center, create Julia  */

	      XButtonPressedEvent  *b;

	      statevars.xcent = tx;
	      statevars.ycent = ty;

	      b = (XButtonPressedEvent *) event;

	      create_popupmenu();

	      XmMenuPosition(popupmenu, b);
	      XtManageChild(popupmenu);
            }

        /*  reset this to prevent trouble  */
        button = -1;
    }
}





void CreateNewScene(bool bInstallHandlers) {

  Widget widget = XtParent(XtParent(daCanvas));
  if (daCanvas)
    {
      if (popupmenu) XtDestroyWidget(popupmenu);
      XtUnmanageChild(daCanvas);
      XtDestroyWidget(daCanvas);
    }
  daCanvas = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, widget,
				     XmNbackground,       whitepixel,
				     XmNwidth,            curState->lWidth,
				     XmNheight,           curState->lHeight,
				     XmNresizePolicy,     XmRESIZE_ANY,
				     NULL);
  XtAddEventHandler(daCanvas, ExposureMask, false, (XtEventHandler) redraw, (XtPointer) NULL);
  XtAddCallback(daCanvas, XmNresizeCallback, (XtCallbackProc) redraw, (XtPointer) NULL);
  
  if (bInstallHandlers) {
    //  re-install the handlers
    XtAddEventHandler(daCanvas, ButtonPressMask,   false, (XtEventHandler) mouseEvent, (XtPointer) DOWN);
    XtAddEventHandler(daCanvas, ButtonReleaseMask, false, (XtEventHandler) mouseEvent, (XtPointer) UP);
    XtAddEventHandler(daCanvas, ButtonMotionMask,  false, (XtEventHandler) mouseEvent, (XtPointer) MOTION);
    XtAddEventHandler(daCanvas, PointerMotionMask, false, (XtEventHandler) mouseEvent, (XtPointer) MOTION);
    XtAddEventHandler(daCanvas, LeaveWindowMask,   false, (XtEventHandler) mouseEvent, (XtPointer) OUT);
  }

  create_popupmenu();

}




void AbortFractal(Widget w, XtPointer client, XtPointer call) {
  int which = (int) client;

    switch (which){
        case ABRTCLR:
            XCopyArea(gpDisplay, old, curState->pix, gGC, 0, 0, curState->lWidth, curState->lHeight, 0, 0);
            XFreePixmap(gpDisplay, old);
            break;

#ifdef ENABLE_JPEG
        case ABRTJPG:
            export_aborted = 1;
            jpeg_destroy((jpeg_common_struct *) &cinfo);
            break;
#endif

        case ABRTPPM:
            export_aborted = 1;
            fclose(exportFile);
            unlink(export_filename);
            break;

        case ABRT:
	    DeleteState((Widget) NULL, (XtPointer) NULL, (XtPointer) NULL);
            break;
            
    }

}


void GoToNext(Widget w, XtPointer client, XtPointer call){
  GoToState(curState->next);
}

void GoToPrev(Widget w, XtPointer client, XtPointer call){
  GoToState(curState->prev);
}




void CreateFractal(short abortable){
    /*  the "meat" of the program  */
  double         xmin, xmax, ymin, ymax;
  long           tempx, tempy, w, h, mi, n=0, cc=0, prevn=-1;
  short          ty, bNoExport;
  bool           d, aborted=false;
  static char    t[32];
  static double  xfa, yfa;

  static Window  win;
  static EComplex z;

  struct timeb   tb, tb2;


  bNoExport = ((abortable==CF_PPM) || (abortable==CF_JPEG))? 0 : 1;
  
  if (abortable==(CF_NORMAL * -1))
    {
      abortable *= -1;
      CreateNewScene(false);
    }

  if (bNoExport)
    win = XtWindow(daCanvas);

  xmin = curState->dXmin;
  xmax = curState->dXmax;
  ymin = curState->dYmin;
  ymax = curState->dYmax;

  w  = curState->lWidth;
  h  = curState->lHeight;
  mi = curState->lMaxIterations;
  d  = curState->bUseColor;
  ty = curState->type;

  curState->function->lMaxIterations = mi;


  /*  ratio of coordinate width/height to pixel width/height  */
  xfa = (xmax-xmin)/w;
  yfa = (ymax-ymin)/h;

  /*
  if ((abortable==CF_NORMAL) && (curState->next==curState))
    TimeoutCursors(true, false, abortable);
  else
    TimeoutCursors(true, true, abortable);
  */
    /* for every pixel on the screen, translate the pixel coordinates
     * to Cartesian coordinates on the scale of [xmin, xmax] and [ymin, ymax].
     * then iterate the function for that  z=(x+yi)  and record n, the number
     * of iterations before we either got over 2 or reached the maximum
     * number of iterations  */

  /*  if we're exporting a JPEG or PPM, allocate memory  */
  if (!bNoExport)//(abortable == CF_JPEG) || (abortable == CF_PPM))
#ifdef ENABLE_JPEG
    image_buffer = (JSAMPLE *) XtMalloc(w*h*3*sizeof(unsigned char));
#else
    image_buffer = (long *) XtMalloc(w*h*3*sizeof(long));
#endif


    /*  if we're changing the color of an existing fractal, set old pixmaps  */
  if (abortable==CF_COLOR){
    old = XCreatePixmap(gpDisplay, win, w, h, DefaultDepthOfScreen(XtScreen(daCanvas)) );
    XCopyArea(gpDisplay, curState->pix, old, gGC, 0, 0, w, h, 0, 0);
  }




ftime(&tb);

 tempy = 0;
 while ( tempy < h ) {

      //
      //
      //  HERE!!! ANOTHER OPTION!!!
      //
      //
      ////////////////////////////////////////////

   //        sprintf(t, "%.0f%% complete", (double) (tempy*100) / h);
   //printf("\rGenerating fractal... %.0f%% complete", (double) (tempy*100) / h);
   //        XtVaSetValues(waitDialog, XtVaTypedArg, XmNmessageString,  XmRString, t, strlen(t)+1, NULL);
   //        XtVaSetValues(messageBar, XtVaTypedArg, XmNlabelString,  XmRString, t, strlen(t)+1, NULL);
   /*
   if (bNoExport)
          if (CheckForInterrupt()){
       //  if we're here, then user wanted to abort generation

       switch (abortable) {
         case CF_COLOR:
	   AbortFractal(NULL, (XtPointer) ABRTCLR, NULL);
	   break;

         case CF_NORMAL:
	   if (curState->next != curState)
	     AbortFractal(NULL, (XtPointer) ABRT, NULL);
	   break;

         case CF_PPM:
	   AbortFractal(NULL, (XtPointer) ABRTPPM, NULL);
	   break;

#ifdef ENABLE_JPEG
         case CF_JPEG:
	   AbortFractal(NULL, (XtPointer) ABRTJPG, NULL);
	   break;
#endif
       }
       aborted=true;
       break;
       }*/
   tempx = 0;
   while ( tempx < w ) {

     if (ty==MANDELBROT) {
       curState->function->parameter.a = xmin + (tempx * xfa);
       curState->function->parameter.b = ymax - (tempy * yfa);
       z.a = z.b = 0;
     }
     else {
       z.a = xmin + (tempx * xfa);
       z.b = ymax - (tempy * yfa);
     }
            
     n = curState->function->Iterate(&z);

     if (bNoExport) {

       if (n!=prevn)
	 {
	   if (n==mi)
	     /*  we reached max iterations, make pixel black  */
	     XSetForeground(gpDisplay, gGC, blackpixel);
	   else
	     if (d)
	       /*  if depth == COLOR, set point appropriately  */
	       XSetForeground(gpDisplay, gGC, gpDisplayColors->GetColor(n));
	     else
	       /*  if depth == BW, set point white  */
	       XSetForeground(gpDisplay, gGC, whitepixel);
	   }


	 //
	 //  YET ANOTHER OPTION
	 //
	 //////////////////////////////////////////////
	 //XDrawPoint(gpDisplay, win, gGC, tempx, tempy);
	 XDrawPoint(gpDisplay, curState->pix, gGC, tempx, tempy);



     } else {
       /*  set info in image_buffer for image export  */
       if (n==mi)
	 {
	 image_buffer[cc++] = 0;
	 image_buffer[cc++] = 0;
	 image_buffer[cc++] = 0;
	 }
       else
	 {
	 image_buffer[cc++] = gpDisplayColors->GetRed(n)   >> 8;
	 image_buffer[cc++] = gpDisplayColors->GetGreen(n) >> 8;
	 image_buffer[cc++] = gpDisplayColors->GetBlue(n ) >> 8;
	 }
     }
     prevn = n;
     tempx++;
   } // x-for
   tempy++;
 } //y-for

ftime(&tb2);
printf("\ttime: %ld\n", (tb2.time*1000 + tb2.millitm) - (tb.time*1000 + tb.millitm));




    //
    // HERE!!! make this an option
    //
    ///////////////////////////////
 if (bNoExport)
   {
   XCopyArea(gpDisplay, curState->pix, win, gGC, 0, 0, curState->lWidth, curState->lHeight, 0, 0);

   sprintf(t, "EyeFract %s", VERSION);
   XtVaSetValues(messageBar, XtVaTypedArg, XmNlabelString,  XmRString, t, strlen(t)+1, NULL);

   /*  turn off working dialog, reset cursors  *
       TimeoutCursors(false, false, abortable);*/


   if (previewDialog)
     {
     if (!aborted)
       previewDialog->curPane->GeneratePreview(curState->pix);

     previewDialog->RefreshAllPanes(firstState, false, false);
     }


   /*  if we are just changing colors, now set state's colors  */
   if (abortable==CF_COLOR)
     curState->eyemap = gpDisplayColors;



   /*  re-install the handlers  */
   XtAddEventHandler(daCanvas, ButtonPressMask,   false, (XtEventHandler) mouseEvent, (XtPointer) DOWN);
   XtAddEventHandler(daCanvas, ButtonReleaseMask, false, (XtEventHandler) mouseEvent, (XtPointer) UP);
   XtAddEventHandler(daCanvas, ButtonMotionMask,  false, (XtEventHandler) mouseEvent, (XtPointer) MOTION);
   XtAddEventHandler(daCanvas, PointerMotionMask, false, (XtEventHandler) mouseEvent, (XtPointer) MOTION);
   XtAddEventHandler(daCanvas, LeaveWindowMask,   false, (XtEventHandler) mouseEvent, (XtPointer) OUT);
   
   }

   gbHasChanged = false;

}



void byebye(Widget w, XtPointer client, XtPointer callback){
    /*  run this function on exit.  free all memory, then exit  */
    XState *temp;

    curState = firstState;
    lastState->next = NULL;

    while (curState) {

      temp = curState->next;
      delete curState;
      curState = temp;

    }

    if (aboutDialog)
      {
      delete aboutDialog;
      aboutDialog = 0;
      }
    
    if (previewDialog)
      {
      delete previewDialog;
      previewDialog = 0;
      }

    XmStringFree(sOpenPar);
    XmStringFree(sClosePar);
    XmStringFree(sComma);
    XFreeColormap(gpDisplay, gColormap);
    XFreeGC(gpDisplay, gGC);
    exit(0);
}



void IterateButtonPressed(Widget wd, XtPointer client, XtPointer callback){
  //  called when the Iterate button received a click
    long     tempi, w, h;
    short    same=-1;
    char     *t="";
    double   txn=-99, txx=-99, tyn=-99, tyx=-99, newa, newb;
    bool     ok = true;
    
    if (!gbHasChanged) return;

    //  run tests of the number of iterations, width and height
    if (!TestAndSetValues(&tempi, &w, &h)) return;

    XtVaGetValues(xminBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, (giCoordDisplayStyle==CS_MINMAX)? "Xmin" : "Xcenter")) )
      txn=atof(t);
    XtVaGetValues(xmaxBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, (giCoordDisplayStyle==CS_MINMAX)? "Xmax" : "Xradius")) )
      txx=atof(t);
    XtVaGetValues(yminBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, (giCoordDisplayStyle==CS_MINMAX)? "Ymin" : "Ycenter")) )
      tyn=atof(t);
    XtVaGetValues(ymaxBox, XmNvalue, &t, NULL);
    if ( (ok = ok && isValueOK(t, (giCoordDisplayStyle==CS_MINMAX)? "Ymax" : "Yradius")) )
      tyx=atof(t);

    newa = newb = 0;
    if (giFractalType == JULIA) {
        XtVaGetValues(aBox, XmNvalue, &t, NULL);
	if ( (ok = ok && isValueOK(t, "complex parameter a")) )
	  newa=atof(t);

        XtVaGetValues(bBox, XmNvalue, &t, NULL);
	if ( (ok = ok && isValueOK(t, "complex parameter b")) )
	  newb=atof(t);
    }



    if (giCoordDisplayStyle==CS_MINMAX)
      {
	//  some smart tests to run
	if (txn>=txx) { printf("ERROR: Xmin must be less than Xmax!\n"); ok=false; }
	if (tyn>=tyx) { printf("ERROR: Ymin must be less than Ymax!\n"); ok=false; }
      }


    if (!ok) return;

    

    if ((curState->lWidth==w) && (curState->lHeight==h)) same=1;

    if (giCoordDisplayStyle==CS_MINMAX)
      NewState(txn, txx, tyn, tyx, w, h, TestUseColor(), tempi, giFractalType, newa, newb);
    else
      NewState(txn-txx, txn+txx, tyn-tyx, tyn+tyx, w, h, TestUseColor(), tempi, giFractalType, newa, newb);


    CreateFractal(CF_NORMAL * same);
    
}














//
//
//  State functions
//
//
///////////////////////////////////////
void UpdateLinks()
{
  /*  if this is the first state, set all pointers appropriately  */
  if (gbInit){
    gbInit = false;

    lastState  = curState;
    firstState = curState;
  }

  curState->next = firstState;
  curState->prev = lastState;
  
  lastState->next = curState;
  firstState->prev = curState;
  lastState = curState;

}


void GoToState(short id){
  XState *temp = firstState;
  
  lastState->next = NULL;
  while (temp)
    {
    if (temp->id == id)  break;
    temp = temp->next;
    }
  lastState->next = firstState;

  if (id==temp->id) GoToState(temp);

}


void GoToState(XState *target){
  short   prevw=curState->lWidth, prevh=curState->lHeight;

  if (gpDisplayColors!=curState->eyemap) delete gpDisplayColors;

  curState = target;

  if ((prevh!=curState->lHeight) || (prevw!=curState->lWidth))
    CreateNewScene(true);

  RefreshParameters();

  redraw(daCanvas, NULL, NULL);

  if (previewDialog)
    previewDialog->SelectPane(target->pane);

  gbHasChanged = false;
}


short GetFunctionPos(){
  short i = -1;
  Widget widget = funcList;

  if (!gbInit)
    {
    for (i=0; i<giNumFuncs; i++)
      if (XmListPosSelected(widget, i+1)) break;
    }
  return (i<0)? 0: i;
}


void InitNewState(){

  UpdateLinks();

  curState->SetupX(topLevel, &gColormap, &gGC, gpDisplayColors);

  // if this is the initial state, and -b was not inputted, create preview dialog
  if ((firstState==lastState) && (!options.bareMode))
    create_previewDialog(true, true);

  previewDialog->NewPane(curState, previewDialog);

  RefreshParameters();

}



void NewState(double xn, double xm, double yn, double ym, long w, long h, bool useColor, long i,
                short type, double a, double b){

  curState = new XState(xn, xm, yn, ym, w, h, useColor, i, type, GetNewFunction(GetFunctionPos(), a, b));
  InitNewState();

}



void DeleteState(Widget widget, XtPointer client, XtPointer call){

  XState *pstate = curState->next;
  XState *deleteme = curState;

  long prevh, prevw;
  prevw = deleteme->lWidth;
  prevh = deleteme->lHeight;

  if (curState->next != curState)
    {
      previewDialog->RemovePane(curState->pane, previewDialog, firstState);

      pstate->prev = deleteme->prev;
      pstate->prev->next = pstate;

      if (deleteme==lastState)
	curState = lastState = pstate->prev;
      else if (deleteme==firstState)
	curState = firstState = pstate;
      else
	curState = pstate;

      lastState->next  = firstState; 
      firstState->prev = lastState;

      delete deleteme;

      if ((prevh!=curState->lHeight) || (prevw!=curState->lWidth))
	CreateNewScene(true);

      GoToState(curState);

    }
}

void load_state(Widget dialog, XtPointer client, XtPointer call){
  /*  load state variables from a file  */
  FILE   *fd;
  char   *file = NULL;
  short   same = -1;
  XState *newState;

    XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;
    if (cbs) {
        /* store filename as file  */
        if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &file))
            return;
    }

    if (dialog)
        {
        XtUnmanageChild(dialog);
        XtDestroyWidget(dialog);
        }

    /*  read file  */
    if ((fd = fopen(file, "r")) == NULL) {
        printf("ERROR:  File %s could not be opened\n", file);
        if (curState)
            return;
        exit(1);
    }

    try{  newState = new XState(file); }
    catch (...)
    {
      curState = lastState;
      return;
    }

    if ((curState) && (gpDisplayColors) && (gpDisplayColors!=curState->eyemap))
      delete gpDisplayColors;

    curState = newState;

    gpDisplayColors = new EyeMap(curState->type, file, gpDisplay, &gColormap, &(curState->bUseColor));

    InitNewState();
    
    CreateFractal(CF_NORMAL * same);

}


void save_state(Widget dialog, XtPointer client, XtPointer call){
    /*  save state variables to a file  */
    char   *file = NULL;
    
    XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;
    if (cbs) {
        /*  store filename as file  */
        if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &file))
            return;
    }

    if ( curState->WriteToFile(file) == 0 ) {
	printf("Save successful - %s\n", file);
    }

    XtUnmanageChild(dialog);
    XtDestroyWidget(dialog);

}



























//
//
//  Export images
//
//
//////////////////////////////////////////////////////////////////////////////////
void ExportPPM(Widget mdialog, XtPointer client, XtPointer call){
  long i, max;

  XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;
  if (cbs) {
    /*  store filename as file  */
    if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &export_filename))
      return;
  }

  export_aborted = 0;

  if (mdialog)
    {
    XtUnmanageChild(mdialog);
    XtDestroyWidget(mdialog);
    }

  CreateFractal(CF_PPM);

  if ( ( exportFile = fopen( export_filename, "w" ) ) != NULL ) {
    fprintf( exportFile, "P6\n%ld %ld\n%d\n", curState->lWidth, curState->lHeight, 65535 );
     
    max = 3*curState->lWidth*curState->lHeight;
    for( i=0; i<max; i++ )
      fprintf( exportFile, "%c", (char) image_buffer[i]);

    fclose(exportFile);

    if (!export_aborted)
      printf("Export successful - %s\n", export_filename);
    else
      unlink(export_filename);
  }
  else
    printf("ERROR:  Unable to open file %s for writing\n", export_filename);
  
  XtFree((char *) image_buffer);

}


#ifdef ENABLE_JPEG
void ExportJPEG(Widget mdialog, XtPointer client, XtPointer call){
    /*  export current image to a JPEG  */
    char      *file = NULL;
    int       row_stride;            /* physical row width in buffer */
    JSAMPROW  row_pointer[1];        /* pointer to a single row */
    struct jpeg_error_mgr jerr;
    
    XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;
    if (cbs) {
        /*  store filename as file  */
        if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &file))
            return;
    }
    else
      file = (char *) client;

    export_aborted=0;

    /*  get rid of file selction dialog */
    if (mdialog)
      {
      XtUnmanageChild(mdialog);
      XtDestroyWidget(mdialog);
      }

    /*  run CreateFractal so that it fills global variable image_buffer  */
    CreateFractal(CF_JPEG);

    row_stride = curState->lWidth * 3;      /* JSAMPLEs per row in image_buffer  */

    cinfo.err = jpeg_std_error(&jerr);
    jpeg_create_compress(&cinfo);

    /*  open file for writing  */
    if ((exportFile = fopen(file, "wb")) == NULL) {
        fprintf(stderr, "ERROR:  Can't open %s\n", file);
        return;
    }
    jpeg_stdio_dest(&cinfo, exportFile);

    /*  set necessary parameters  */
    cinfo.image_width  = curState->lWidth;
    cinfo.image_height = curState->lHeight;
    cinfo.input_components = 3;
    cinfo.in_color_space = JCS_RGB;
    cinfo.dct_method = JDCT_ISLOW;         /* best algorithm */

    jpeg_set_defaults(&cinfo);

    jpeg_set_quality(&cinfo, 100, TRUE);   /* highest quality setting */

    jpeg_start_compress(&cinfo, TRUE);

    while (cinfo.next_scanline < cinfo.image_height) {
        row_pointer[0] = &image_buffer[cinfo.next_scanline * row_stride];
	jpeg_write_scanlines(&cinfo, row_pointer, 1);
    }

    jpeg_finish_compress(&cinfo);
    fclose(exportFile);

    if (!export_aborted)
      printf("Export successful - %s\n", file);
    else
      unlink(file);

    jpeg_destroy_compress(&cinfo);

    XtFree((char *) image_buffer);
}
#endif
























//
//
//  Colormap functions
//
//
////////////////////////////////////////////////////////////////////////////////
void UpdateColorDialog()
{
  short i;

  if (colorDialog)
    for (i=0; i<NUM_COLORS; i++)
      XtVaSetValues(buttons[i], XmNbackground, gpDisplayColors->GetColor(i), NULL);

}


void ImportColormap(Widget mdialog, XtPointer client, XtPointer call){
    /*  import colormap from a file  */
    char    *file    = NULL;
    EyeMap  *tempMap = 0;

    XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;

    if (cbs) {
      if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &file)) {
	printf("ERROR:  Could not get filename\n");
	return;
      }
    }

    if (mdialog){
        XtUnmanageChild(mdialog);
        XtDestroyWidget(mdialog);
    }

    tempMap = new EyeMap(file, gpDisplay, &gColormap);


    if (!tempMap) {
        printf("ERROR: %s is not a valid colormap file\n", file);
	return;
    }

    gpDisplayColors = tempMap;

    gbHasChanged = true;

    if (colorDialog) {
      UpdateColorDialog();
      SelectColormapEntry(NULL, 0, NULL);
    }

}


void ExportColormap(Widget mdialog, XtPointer client, XtPointer call){
    /*  export colormap to a file  */
    char   *file = NULL;
    
    XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call;
    if (cbs) {
      if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &file))
	return;
    }

    printf("Export %s - %s\n", (gpDisplayColors->WriteToFile(file))? "failed" : "successful", file);
    
}



void SelectColormapEntry(Widget w, XtPointer client, XtPointer call){

  XtVaSetValues(buttons[curCol], XmNbackground, oldColor.pixel, NULL);

  curCol  = (int) client;

  //  set the scales
  XtVaSetValues(rscale, XmNvalue, gpDisplayColors->GetRed(curCol),   NULL);
  XtVaSetValues(gscale, XmNvalue, gpDisplayColors->GetGreen(curCol), NULL);
  XtVaSetValues(bscale, XmNvalue, gpDisplayColors->GetBlue(curCol),  NULL);

  gpDisplayColors->StoreColor(curCol, &oldColor);

  XtVaSetValues(appcolbtn, XmNsensitive, false, NULL);
  XtVaSetValues(revcolbtn, XmNsensitive, false, NULL);
}

void UpdateColormapEntryColor(Widget w, XtPointer client, XtPointer call){
    /*  slider was moved
     *  adjust value of the appropriate cell in gaDisplayColors[]
     *  update display  */
    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call;

    if (curCol<0) return;

    if (gpDisplayColors==curState->eyemap)
      gpDisplayColors = new EyeMap(gpDisplay, &gColormap, curState->eyemap->colors);

    gpDisplayColors->UpdateEntry(curCol, (int) client, cbs->value);

    XtVaSetValues(buttons[curCol], XmNbackground, gpDisplayColors->colors[curCol].pixel, NULL);

    /*  value has changed, allow revert and apply buttons to be sensitive  */
    XtVaSetValues(revcolbtn, XmNsensitive, true, NULL);
    XtVaSetValues(appcolbtn, XmNsensitive, true, NULL);
}


void RevertColormapEntry(Widget w, XtPointer client, XtPointer call){
  //  eliminate the change to the color in the map

  XtVaSetValues(buttons[curCol], XmNbackground, oldColor.pixel, NULL);
  gpDisplayColors->SetEntry(curCol, oldColor);

  /*  now do what function title says, and set the scales  */
  XtVaSetValues(rscale, XmNvalue, gpDisplayColors->GetRed(curCol),   NULL);
  XtVaSetValues(gscale, XmNvalue, gpDisplayColors->GetGreen(curCol), NULL);
  XtVaSetValues(bscale, XmNvalue, gpDisplayColors->GetBlue(curCol),  NULL);

  XtVaSetValues(revcolbtn, XmNsensitive, false, NULL);
  XtVaSetValues(appcolbtn, XmNsensitive, false, NULL);
}


void SaveColormapEntry(Widget w, XtPointer client, XtPointer call){
  //  accept the change to the color in the map

  XtVaSetValues(revcolbtn, XmNsensitive, false, NULL);
  XtVaSetValues(appcolbtn, XmNsensitive, false, NULL);

  oldColor = gpDisplayColors->GetXColor(curCol);

  gbHasChanged = true;
}


void UpdateNewColorPreview(Widget w, XtPointer client, XtPointer call){
    /*  update preview color in create CMAP window  */
    short which = (int) client;
    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call;

    if (which<0)  { /* color 1 */
        which *= -1;

        switch (which) {
            case DoRed:
                gHiColor.red = (cbs->value);
                break;
            case DoGreen:
                gHiColor.green = (cbs->value);
                break;
            case DoBlue:
                gHiColor.blue = (cbs->value);
                break;
        }
        XAllocColor(gpDisplay, gColormap, &gHiColor);
        XtVaSetValues(prevhi, XmNbackground, gHiColor.pixel, NULL);

    } else {  /* color 2 */

        switch (which) {
            case DoRed:
                gLowColor.red = (cbs->value);
                break;
            case DoGreen:
                gLowColor.green = (cbs->value);
                break;
            case DoBlue:
                gLowColor.blue = (cbs->value);
                break;
        }
        XAllocColor(gpDisplay, gColormap, &gLowColor);
        XtVaSetValues(prevlow, XmNbackground, gLowColor.pixel, NULL);
    }
}


void GenerateColormap(Widget w, XtPointer cli, XtPointer ca){
    /*  generate the colormap, based on XColors gHiColor and gLowColor  */
    short  redch, bluech, greench, str, j, length, remainder=0, in;
    char   *s="";
    unsigned short i;

    XtVaGetValues(numStripes, XmNvalue, &s, NULL);
    if (!isValueOK(s, "number of stripes"))
	return;
    str = atoi(s);


    if ((str<0) || (str>64)) { 
        printf("ERROR: The number of stripes must be in the range of [0, 64]\n");
        return;
    }


    if (str==0) {
        length = NUM_COLORS*2;
        remainder = 0;
    }
    else {
        length = NUM_COLORS/str;
        if (length * str != NUM_COLORS) remainder = NUM_COLORS - (length * str);
    }

    
    redch   = (gHiColor.red   - gLowColor.red)   / (length/2);
    greench = (gHiColor.green - gLowColor.green) / (length/2);
    bluech  = (gHiColor.blue  - gLowColor.blue)  / (length/2);

    for (i=0; i<NUM_COLORS; i++){

        j = i % length;
        if (remainder) {
            for (in=1; in<(str*2); in+=2) {
	      if (i==(NUM_COLORS*in)/(str*2)) {
		  gpDisplayColors->SetEntry(i, gpDisplayColors->colors[i-1]);
      		  i++;
		  break;
                }
            }
        }
        if (j<(length/2)) {
	  gpDisplayColors->SetRed(i,   gHiColor.red   - ((j+1)*redch));
	  gpDisplayColors->SetGreen(i, gHiColor.green - ((j+1)*greench));
	  gpDisplayColors->SetBlue(i,  gHiColor.blue  - ((j+1)*bluech));
	}
        else if (j>(length/2))
	  gpDisplayColors->SetEntry(i, gpDisplayColors->colors[length-1-j]);
        else
	  gpDisplayColors->SetEntry(i, gLowColor);

    } /* end for each cell */

    gbHasChanged = true;


    UpdateColorDialog();

    XtVaSetValues(rscale, XmNvalue, gpDisplayColors->GetRed(curCol),   NULL);
    XtVaSetValues(gscale, XmNvalue, gpDisplayColors->GetGreen(curCol), NULL);
    XtVaSetValues(bscale, XmNvalue, gpDisplayColors->GetBlue(curCol),  NULL);

    XtUnmanageChild(newColormapDialog);

}


void MapListSelection(Widget w, XtPointer cli, XtPointer ca){
  XmListCallbackStruct *cbs = (XmListCallbackStruct *) ca;
  char *choice, base[270]="./maps/";
  XmFileSelectionBoxCallbackStruct f;

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &choice);
  strcat(base, choice);

  f.value = XmStringCreateLocalized(base);
  ImportColormap(NULL, NULL, &f);

  XtFree(choice);
}























//
//
//   Menu Callbacks
//
//
////////////////////////////////////////////////

void StateMenuSelect(Widget w, XtPointer client, XtPointer call){
    /*  callback function for the State menu  */
    short     item = (int) client;
    Arg       args[1];
    Widget    dialog;
    XmString  mask;

    switch (item) {
        case 0: /*  load file  */
            /*  first set directory filter  */
            mask = XmStringCreateLocalized("states/*.[mj]sn");

            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Load State", args, 1);
            XtAddCallback(dialog, XmNokCallback, load_state, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, dialog);

            XmStringFree(mask);
            XtManageChild(dialog);
            break;

        case 1:    /*  save file  */
            if (gbInit) break;

            /*  first set directory filter  */
            if (giFractalType == JULIA)
                mask = XmStringCreateLocalized("states/*.jsn");
            else
                mask = XmStringCreateLocalized("states/*.msn");

            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Save State", args, 1);
            XtAddCallback(dialog, XmNokCallback, save_state, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, NULL);

            XmStringFree(mask);

            XtManageChild(dialog);
            break;

        case 2:  /*  import colormap...  */
            mask = XmStringCreateLocalized("maps/*.map");
            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Import Colormap", args, 1);

            XtAddCallback(dialog, XmNokCallback, ImportColormap, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, NULL);

            XmStringFree(mask);

            XtManageChild(dialog);
            break;

        case 3:  /*  export colormap...  */
            mask = XmStringCreateLocalized("maps/*.map");
            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Export Colormap", args, 1);

            XtAddCallback(dialog, XmNokCallback, ExportColormap, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, NULL);

            XmStringFree(mask);

            XtManageChild(dialog);
            break;

        case 4:

#ifdef ENABLE_JPEG
        /*  Export JPEG...  */
            mask = XmStringCreateLocalized("images/*.jpg");
            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Export JPEG", args, 1);
            XtAddCallback(dialog, XmNokCallback, ExportJPEG, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, NULL);

            XmStringFree(mask);

            XtManageChild(dialog);
            break;

        case 5:
#endif
        /*  Export PPM...  */
            mask = XmStringCreateLocalized("images/*.ppm");
            XtSetArg(args[0], XmNdirMask, mask);

            dialog = XmCreateFileSelectionDialog(topLevel, "Export PPM", args, 1);
            XtAddCallback(dialog, XmNokCallback, ExportPPM, NULL);
            XtAddCallback(dialog, XmNcancelCallback, (XtCallbackProc) XtUnmanageChild, NULL);

            XmStringFree(mask);

            XtManageChild(dialog);
            break;

#ifdef ENABLE_JPEG
        case 6:
#else
        case 5:
#endif
        /*  quit  */
            byebye(NULL, NULL, NULL);
            break;
    }
}


void TypeMenuSelect(Widget w, XtPointer client, XtPointer call){
    /*  callback function for the Type menu  */
    short   item = (int) client;
    Widget  widget;

    switch (item) {
        case 0: /*  Julia  */
            /* enable the a+bi boxes, set background to white
             * make sure menu radio boxes are set properly  */
            if (giFractalType==JULIA) return;
            giFractalType = JULIA;

            if (aBox){
                XtVaSetValues(aBox, XmNsensitive, true, XmNbackground, whitepixel, NULL);
                XtVaSetValues(bBox, XmNsensitive, true, XmNbackground, whitepixel, NULL);
            }
	    
            if ( (widget = XtNameToWidget(typeMenu, "button_0")) != NULL)
                XtVaSetValues(widget, XmNset, true, NULL);	    
            if ( (widget = XtNameToWidget(typeMenu, "button_1")) != NULL)
                XtVaSetValues(widget, XmNset, false, NULL);
            gbHasChanged = true;
            break;

        case 1: /*  Mandelbrot  */
            /* disable the a+bi boxes, set background to gray
             * make sure menu radio boxes are set properly  */
            if (giFractalType==MANDELBROT) return;
            giFractalType = MANDELBROT;

            if (aBox){
                XtVaSetValues(aBox, XmNsensitive, false,
                    XtVaTypedArg, XmNbackground, XmRString, "gray", strlen("gray"+1),
                    NULL);
                XtVaSetValues(bBox, XmNsensitive, false,
                    XtVaTypedArg, XmNbackground, XmRString, "gray", strlen("gray"+1),
                    NULL);
            }
	    
            if ( (widget = XtNameToWidget(typeMenu, "button_0")) != NULL )
                XtVaSetValues(widget, XmNset, false, NULL);
            if ( (widget = XtNameToWidget(typeMenu, "button_1")) != NULL)
                XtVaSetValues(widget, XmNset, true, NULL);	    
	    
            gbHasChanged = true;
            break;

        case 2: /*  Color  */
            gbHasChanged = true;
            break;
    }
}


void ViewMenuSelect(Widget w, XtPointer client, XtPointer call){
    short item = (int) client;
    XmToggleButtonCallbackStruct *tbc = (XmToggleButtonCallbackStruct *) call;

    switch (item){
        case 0:  /*  parameters  */
	  if (tbc->set)
	    create_paramDialog(true);
	  else
	    close_dialog(NULL, (XtPointer) paramDialog, NULL);
	  break;

        case 1:  /*  color  */
	  if (tbc->set)
	    create_colorDialog(true);
	  else
	    close_dialog(NULL, (XtPointer) colorDialog, NULL);
	  break;

        case 2:  /*  preview  */
	  if (previewDialog)
	    {
	      delete previewDialog;
	      previewDialog = 0;
	    }
	  else
	    create_previewDialog(false, true);

	  break;
    }
}


void HelpMenuSelect(Widget w, XtPointer client, XtPointer call){
    short item = (int) client;

    switch (item){
        case 0:  /*  About...  */
	  if (!aboutDialog) {
	    aboutDialog = new dlgAbout(topLevel);
	  }
	  break;
    }
}


void PopupMenuSelect(Widget widget, XtPointer client, XtPointer call){
  short    which=(int) client, same=-1;

  double   cw=-1, ch=-1, zf;
  char     *t="";

  double   xi = curState->dXmin;
  double   xa = curState->dXmax;
  double   yi = curState->dYmin;
  double   ya = curState->dYmax;
  double   a  = curState->function->parameter.a;
  double   b  = curState->function->parameter.b;
  short    type = curState->type;

  long     tempi, h, w;
  if (!TestAndSetValues(&tempi, &w, &h)) return;


    switch (which){
    case DO_CHANGECOLORS:
      CreateFractal(CF_COLOR);
      return;
      break;


    case DO_MANDELBROT:
      cw = (curState->dXmax-curState->dXmin)/2;
      ch = (curState->dYmax-curState->dYmin)/2;

      xi = statevars.xcent-cw;
      xa = statevars.xcent+cw;
      yi = statevars.ycent-ch;
      ya = statevars.ycent+ch;
      type = MANDELBROT;

      TypeMenuSelect(NULL, (XtPointer) MANDELBROT, NULL);
      break;


    case DO_JULIA:
      a = statevars.xcent;
      b = statevars.ycent;

      type = JULIA;
      TypeMenuSelect(NULL, (XtPointer) JULIA, NULL);

      break;

    case DO_ZOOMIN:

      XtVaGetValues(zoomBox, XmNvalue, &t, NULL);
      if (!isValueOK(t, "Zoom factor"))
	return;
      else
	zf = atof(t);
      if (zf<1) { printf("ERROR: The zoom factor must be greater than 1.\n"); return; }


      dZoomFactor = zf;
      cw = (curState->dXmax - curState->dXmin) / dZoomFactor;
      ch = (curState->dYmax - curState->dYmin) / dZoomFactor;

      xi = statevars.xcent - (cw/2);
      xa = statevars.xcent + (cw/2);
      yi = statevars.ycent - (ch/2);
      ya = statevars.ycent + (ch/2);

      break;

    case DO_ZOOMOUT:

      XtVaGetValues(zoomBox, XmNvalue, &t, NULL);
      if (!isValueOK(t, "Zoom factor"))
	return;
      else
	zf = atof(t);
      if (zf<1) { printf("ERROR: The zoom factor must be greater than 1.\n"); return; }


      dZoomFactor = zf;
      cw = (curState->dXmax - curState->dXmin) * dZoomFactor;
      ch = (curState->dYmax - curState->dYmin) * dZoomFactor;

      xi = statevars.xcent - (cw/2);
      xa = statevars.xcent + (cw/2);
      yi = statevars.ycent - (ch/2);
      ya = statevars.ycent + (ch/2);

      break;

    case DO_RECENTER:
      cw = curState->dXmax - curState->dXmin;
      ch = curState->dYmax - curState->dYmin;

      if (((curState->dXmin + (cw/2)) >= (statevars.xcent - 0.000000000000001)) && 
	  ((curState->dXmin + (cw/2)) <= (statevars.xcent + 0.000000000000001)) &&
	  ((curState->dYmin + (ch/2)) >= (statevars.ycent - 0.000000000000001)) && 
	  ((curState->dYmin + (ch/2)) <= (statevars.ycent + 0.000000000000001)))
	{
	printf("Image already centered\n");
	return;
	}

      xi = statevars.xcent - (cw/2);
      xa = statevars.xcent + (cw/2);
      yi = statevars.ycent - (ch/2);
      ya = statevars.ycent + (ch/2);

      break;

    case DO_RESCALE_FROMHERE:
      cw = curState->dXmax - curState->dXmin;
      ch = curState->dYmax - curState->dYmin;

      if (((cw/w) >= ((ch/h) - 0.000000000000001)) && ((cw/w) <= ((ch/h) + 0.000000000000001)) &&
	  ((curState->dXmin + (cw/2)) >= (statevars.xcent - 0.000000000000001)) && 
	  ((curState->dXmin + (cw/2)) <= (statevars.xcent + 0.000000000000001)) &&
	  ((curState->dYmin + (ch/2)) >= (statevars.ycent - 0.000000000000001)) && 
	  ((curState->dYmin + (ch/2)) <= (statevars.ycent + 0.000000000000001)))
	{
        printf("Image already centered and scaled properly\n");
	return;
	}
      else if ((cw/w) < (ch/h))
	cw = (ch*w/h);
      else
	ch = (cw*h/w);

      xi = statevars.xcent - (cw/2);
      xa = statevars.xcent + (cw/2);
      yi = statevars.ycent - (ch/2);
      ya = statevars.ycent + (ch/2);

      break;


    case DO_RESCALE_FROMCENTER:
      cw = (curState->dXmax - curState->dXmin);
      ch = (curState->dYmax - curState->dYmin);

      if (((cw/w) >= ((ch/h) - 0.000000000000001)) && ((cw/w) <= ((ch/h) + 0.000000000000001)))
	{
	printf("Image already scaled properly\n");
	return;
	}
      else if ((cw/w) < (ch/h))
	cw = (ch*w/h);
      else
	ch = (cw*h/w);

      xi = ((curState->dXmax + curState->dXmin) / 2) - (cw/2);
      xa = ((curState->dXmax + curState->dXmin) / 2) + (cw/2);
      yi = ((curState->dYmax + curState->dYmin) / 2) - (ch/2);
      ya = ((curState->dYmax + curState->dYmin) / 2) + (ch/2);

      break;
    }



    if ((curState->lWidth==w) && (curState->lHeight==h)) same=1;

    NewState(xi, xa, yi, ya, w, h, TestUseColor(), tempi, type, a, b);

    CreateFractal(CF_NORMAL * same);


}
















//
//
//  Dialogs
//
//
////////////////////////////////////////////////////



void create_newColormapDialog(Widget w, XtPointer client, XtPointer call){
    Widget tform, sep, rc, ncform, okbtn;

    if (!newColormapDialog){
      gHiColor.red   = curState->eyemap->GetRed(0);
      gHiColor.green = curState->eyemap->GetGreen(0);
      gHiColor.blue  = curState->eyemap->GetBlue(0);
      XAllocColor(gpDisplay, gColormap, &gHiColor);

      gLowColor.red   = curState->eyemap->GetRed(NUM_COLORS-1);
      gLowColor.green = curState->eyemap->GetGreen(NUM_COLORS-1);
      gLowColor.blue  = curState->eyemap->GetBlue(NUM_COLORS-1);
        XAllocColor(gpDisplay, gColormap, &gLowColor);

        newColormapDialog = XtVaCreatePopupShell( "New Colormap",
                          xmDialogShellWidgetClass, topLevel,
                          XmNx,    500,       XmNy,     200,
                          XmNwidth,           350,
                          XmNheight,          500,
                          XmNresizePolicy,    XmRESIZE_NONE,
                          XmNdeleteResponse,  XmDESTROY,
                          NULL);

        newColormapPane = XtVaCreateWidget("copane", xmPanedWindowWidgetClass, newColormapDialog,
                          XmNsashWidth,   1,
                          XmNsashHeight,  1,
                          NULL);

        tform  = XtVaCreateManagedWidget("top", xmFormWidgetClass, newColormapPane,
                          XmNnumColumns,          16,
                          XmNorientation,         XmHORIZONTAL,
                          XmNpacking,             XmPACK_TIGHT,
                          XmNleftAttachment,      XmATTACH_FORM,
                          XmNtopAttachment,       XmATTACH_FORM,
                          NULL);

        sep = XtVaCreateManagedWidget("Color 1:", xmLabelWidgetClass, tform,
                          XmNleftAttachment,    XmATTACH_FORM,
                          XmNtopAttachment,     XmATTACH_FORM,
                          XmNheight,            20,
                          NULL);

        rc = XtVaCreateManagedWidget("rc", xmRowColumnWidgetClass, tform,
                          XmNorientation,     XmHORIZONTAL,
                          XmNleftAttachment,  XmATTACH_FORM,
                          XmNtopAttachment,   XmATTACH_WIDGET,
                          XmNtopWidget,       sep,
			  NULL);

        prevhi = XtVaCreateManagedWidget("HiPreview", xmDrawingAreaWidgetClass, rc,
                          XmNbackground,   gHiColor.pixel,
                          XmNwidth,        50,
                          XmNheight,       50,
                          NULL);

        rs1 = XtVaCreateManagedWidget("Red", xmScaleWidgetClass, rc,
                          XmNvalue,           gHiColor.red,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Red", 4,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Red", 4,
                          NULL);
        XtAddCallback(rs1, XmNdragCallback, UpdateNewColorPreview, (XtPointer) (DoRed * -1));
        XtAddCallback(rs1, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) (DoRed * -1));

        gs1 = XtVaCreateManagedWidget("Green", xmScaleWidgetClass, rc,
                          XmNvalue,           gHiColor.green,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Green", 6,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Green", 6,
                          NULL);
        XtAddCallback(gs1, XmNdragCallback, UpdateNewColorPreview, (XtPointer) (DoGreen * -1));
        XtAddCallback(gs1, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) (DoGreen * -1));

        bs1 = XtVaCreateManagedWidget("Blue", xmScaleWidgetClass, rc,
                          XmNvalue,           gHiColor.blue,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Blue", 5,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Blue", 5,
                          NULL);
        XtAddCallback(bs1, XmNdragCallback, UpdateNewColorPreview, (XtPointer) (DoBlue * -1));
        XtAddCallback(bs1, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) (DoBlue * -1));

        sep = XtVaCreateManagedWidget("Color 2:", xmLabelWidgetClass, tform,
                          XmNleftAttachment,    XmATTACH_FORM,
                          XmNtopAttachment,     XmATTACH_WIDGET,
                          XmNtopWidget,         rc,
                          XmNtopOffset,         20,
                          XmNheight,            20,
                          NULL);

        rc = XtVaCreateManagedWidget("rc", xmRowColumnWidgetClass, tform,
                          XmNorientation,     XmHORIZONTAL,
                          XmNleftAttachment,  XmATTACH_FORM,
                          XmNtopAttachment,   XmATTACH_WIDGET,
                          XmNtopWidget,       sep,
                          NULL);

        prevlow = XtVaCreateManagedWidget("LowPreview", xmDrawingAreaWidgetClass, rc,
                          XmNbackground,   gLowColor.pixel,
                          XmNwidth,        50,
                          XmNheight,       50,
                          NULL);
        rs2 = XtVaCreateManagedWidget("Red", xmScaleWidgetClass, rc,
                          XmNvalue,           gLowColor.red,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Red", 4,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Red", 4,
                          NULL);
        XtAddCallback(rs2, XmNdragCallback, UpdateNewColorPreview, (XtPointer) DoRed);
        XtAddCallback(rs2, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) DoRed);

        gs2 = XtVaCreateManagedWidget("Green", xmScaleWidgetClass, rc,
                          XmNvalue,           gLowColor.green,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Green", 6,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Green", 6,
                          NULL);
        XtAddCallback(gs2, XmNdragCallback, UpdateNewColorPreview, (XtPointer) DoGreen);
        XtAddCallback(gs2, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) DoGreen);

        bs2 = XtVaCreateManagedWidget("Blue", xmScaleWidgetClass, rc,
                          XmNvalue,           gLowColor.blue,
                          XmNshowValue,       false,
                          XmNmaximum,         65535,
                          XmNscaleMultiple,   50,
                          XtVaTypedArg,       XmNtitleString,  XmRString, "Blue", 5,
                          XtVaTypedArg,       XmNforeground,   XmRString, "Blue", 5,
                          NULL);
        XtAddCallback(bs2, XmNdragCallback, UpdateNewColorPreview, (XtPointer) DoBlue);
        XtAddCallback(bs2, XmNvalueChangedCallback, UpdateNewColorPreview, (XtPointer) DoBlue);


        sep = XtVaCreateManagedWidget("Number of stripes [0-64]:  ", xmLabelWidgetClass, tform,
                          XmNleftAttachment,    XmATTACH_FORM,
                          XmNtopAttachment,     XmATTACH_WIDGET,
                          XmNtopWidget,         rc,
                          XmNheight,            30,
                          NULL);

        numStripes = XtVaCreateManagedWidget("stripesBox", xmTextFieldWidgetClass, tform,
                          XmNvalue,            "2",
                          XmNtopAttachment,    XmATTACH_WIDGET,
                          XmNtopWidget,        rc,
                          XmNleftAttachment,   XmATTACH_WIDGET,
                          XmNleftWidget,       sep,
                          XmNwidth,            50,
                          XmNheight,           30,
		          XmNforeground,       blackpixel,
                          XmNbackground,       whitepixel,
                          NULL);

        ncform = XtVaCreateManagedWidget("action_area", xmFormWidgetClass, newColormapPane,
                          XmNfractionBase,    7,
                          NULL);

        okbtn = XtVaCreateManagedWidget("Generate", xmPushButtonWidgetClass, ncform,
                          XmNleftAttachment,   XmATTACH_POSITION,
                          XmNleftPosition,     1,
                          XmNrightAttachment,  XmATTACH_POSITION,
                          XmNrightPosition,    3,
                          NULL);
        XtAddCallback(okbtn, XmNactivateCallback, GenerateColormap, NULL);

        okbtn = XtVaCreateManagedWidget("Cancel", xmPushButtonWidgetClass, ncform,
                          XmNleftAttachment,   XmATTACH_POSITION,
                          XmNleftPosition,     4,
                          XmNrightAttachment,  XmATTACH_POSITION,
                          XmNrightPosition,    6,
                          NULL);
        XtAddCallback(okbtn, XmNactivateCallback, close_dialog, newColormapDialog);


    }

    XtVaSetValues(rs1, XmNvalue, gHiColor.red, NULL);
    XtVaSetValues(gs1, XmNvalue, gHiColor.green, NULL);
    XtVaSetValues(bs1, XmNvalue, gHiColor.blue, NULL);

    XtVaSetValues(rs2, XmNvalue, gLowColor.red, NULL);
    XtVaSetValues(gs2, XmNvalue, gLowColor.green, NULL);
    XtVaSetValues(bs2, XmNvalue, gLowColor.blue, NULL);
    
    XtVaSetValues(prevhi, XmNbackground, gHiColor.pixel, NULL);
    XtVaSetValues(prevlow, XmNbackground, gLowColor.pixel, NULL);

    XtManageChild(newColormapPane);
    XtManageChild(newColormapDialog);

}


void create_colorDialog(bool show){
  Widget  tform;
  int   i, j=0;
  Widget  okbtn, rc, sep;

  DIR *dp;
  struct dirent *dirp;
  short num = 0;


    if (!colorDialog){

        colorDialog = XtVaCreatePopupShell( "Color Settings",
					    xmDialogShellWidgetClass, topLevel,
					    XmNx,    700,       XmNy,     0,
					    XmNwidth,           350,
					    XmNheight,          500,
					    XmNresizePolicy,    XmRESIZE_NONE,
					    XmNdeleteResponse,  XmDESTROY,
					    NULL);
	XtAddCallback(colorDialog, XmNpopdownCallback, close_dialog, (XtPointer) colorDialog);
	XtAddCallback(colorDialog, XmNdestroyCallback, close_dialog, (XtPointer) colorDialog);

	copane = XtVaCreateWidget("color layoutmanager", xmPanedWindowWidgetClass, colorDialog,
                   XmNsashWidth,   1,
                   XmNsashHeight,  1,
                   NULL);
	
        tform  = XtVaCreateManagedWidget("top", xmFormWidgetClass, copane,
					 XmNnumColumns,          16,
					 XmNfractionBase,        13,
					 XmNorientation,         XmHORIZONTAL,
					 XmNpacking,             XmPACK_TIGHT,
					 XmNleftAttachment,      XmATTACH_FORM,
					 XmNbottomAttachment,    XmATTACH_FORM,
					 XmNtopAttachment,       XmATTACH_FORM,
					 NULL);

        okbtn = XtVaCreateManagedWidget("New", xmPushButtonWidgetClass, tform,
					XmNbottomAttachment, XmATTACH_FORM,
					XmNleftAttachment,   XmATTACH_POSITION,
					XmNleftPosition,     1,
					XmNrightAttachment,  XmATTACH_POSITION,
					XmNrightPosition,    3,
					NULL);
        XtAddCallback(okbtn, XmNactivateCallback, create_newColormapDialog, NULL);

        okbtn = XtVaCreateManagedWidget("Import", xmPushButtonWidgetClass, tform,
					XmNbottomAttachment, XmATTACH_FORM,
					XmNleftAttachment,   XmATTACH_POSITION,
					XmNleftPosition,     4,
					XmNrightAttachment,  XmATTACH_POSITION,
					XmNrightPosition,    6,
					NULL);
        XtAddCallback(okbtn, XmNactivateCallback, StateMenuSelect, (XtPointer) LOAD);

        okbtn = XtVaCreateManagedWidget("Export", xmPushButtonWidgetClass, tform,
					XmNbottomAttachment, XmATTACH_FORM,
					XmNleftAttachment,   XmATTACH_POSITION,
					XmNleftPosition,     7, 
					XmNrightAttachment,  XmATTACH_POSITION,
					XmNrightPosition,    9,
					NULL);
        XtAddCallback(okbtn, XmNactivateCallback, StateMenuSelect, (XtPointer) SAVE);

        okbtn = XtVaCreateManagedWidget("Hide", xmPushButtonWidgetClass, tform,
					XmNbottomAttachment, XmATTACH_FORM,
					XmNleftAttachment,   XmATTACH_POSITION,
					XmNleftPosition,     10,
					XmNrightAttachment,  XmATTACH_POSITION,
					XmNrightPosition,    12,
					NULL);
        XtAddCallback(okbtn, XmNactivateCallback, close_dialog, colorDialog);




        rc = XtVaCreateManagedWidget("rc", xmRowColumnWidgetClass, tform,
				     XmNorientation,      XmHORIZONTAL,
				     XmNleftAttachment,   XmATTACH_FORM,
				     XmNbottomAttachment, XmATTACH_WIDGET,
				     XmNbottomWidget,     okbtn,
				     XmNbottomOffset,     20,
				     NULL);

        rscale = XtVaCreateManagedWidget("Red", xmScaleWidgetClass, rc,
                   XmNvalue,           gpDisplayColors->GetRed(0),
                   XmNshowValue,       false,
                   XmNmaximum,         65535,
                   XmNscaleMultiple,   50,
                   XtVaTypedArg,       XmNtitleString,  XmRString, "Red", 4,
                   XtVaTypedArg,       XmNforeground,   XmRString, "Red", 4,
                   NULL);
        XtAddCallback(rscale, XmNdragCallback, UpdateColormapEntryColor, (XtPointer) DoRed);
        XtAddCallback(rscale, XmNvalueChangedCallback, UpdateColormapEntryColor, (XtPointer) DoRed);

        gscale = XtVaCreateManagedWidget("Green", xmScaleWidgetClass, rc,
                   XmNvalue,           gpDisplayColors->GetGreen(0),
                   XmNshowValue,       false,
                   XmNmaximum,         65535,
                   XmNscaleMultiple,   50,
                   XtVaTypedArg,       XmNtitleString,  XmRString, "Green", 6,
                   XtVaTypedArg,       XmNforeground,   XmRString, "Green", 6,
                   NULL);
        XtAddCallback(gscale, XmNdragCallback, UpdateColormapEntryColor, (XtPointer) DoGreen);
        XtAddCallback(gscale, XmNvalueChangedCallback, UpdateColormapEntryColor, (XtPointer) DoGreen);

        bscale = XtVaCreateManagedWidget("Blue", xmScaleWidgetClass, rc,
                   XmNvalue,           gpDisplayColors->GetBlue(0),
                   XmNshowValue,       false,
                   XmNmaximum,         65535,
                   XmNscaleMultiple,   50,
                   XtVaTypedArg,       XmNtitleString,  XmRString, "Blue", 5,
                   XtVaTypedArg,       XmNforeground,   XmRString, "Blue", 5,
                   NULL);
        XtAddCallback(bscale, XmNdragCallback, UpdateColormapEntryColor, (XtPointer) DoBlue);
        XtAddCallback(bscale, XmNvalueChangedCallback, UpdateColormapEntryColor, (XtPointer) DoBlue);

        sep = XtVaCreateManagedWidget("rc2", xmRowColumnWidgetClass, rc,
                   XmNorientation,     XmVERTICAL,
                   XmNnumColumns,      1,
                   XmNrightAttachment, XmATTACH_FORM,
                   XmNleftAttachment,  XmATTACH_WIDGET,
                   XmNleftWidget,      bscale,
                   NULL);
        revcolbtn = XtVaCreateManagedWidget("Revert", xmPushButtonWidgetClass, sep,
                   XmNrightAttachment,  XmATTACH_FORM,
                   XmNtopAttachment,    XmATTACH_FORM,
                   XmNsensitive,        false,
                   NULL);
        XtAddCallback(revcolbtn, XmNactivateCallback, RevertColormapEntry, NULL);
        appcolbtn = XtVaCreateManagedWidget("Apply", xmPushButtonWidgetClass, sep,
                   XmNrightAttachment,  XmATTACH_FORM,
                   XmNtopAttachment,    XmATTACH_WIDGET,
                   XmNtopWidget,        revcolbtn,
                   XmNsensitive,        false,
                   NULL);
        XtAddCallback(appcolbtn, XmNactivateCallback, SaveColormapEntry, NULL);
        okbtn = XtVaCreateManagedWidget("Iterate", xmPushButtonWidgetClass, sep,
                   XmNrightAttachment,  XmATTACH_FORM,
                   XmNtopAttachment,    XmATTACH_WIDGET,
                   XmNtopWidget,        appcolbtn,
                   NULL);
        XtAddCallback(okbtn, XmNactivateCallback, IterateButtonPressed, NULL);
       


	okbtn = XtVaCreateManagedWidget("listform", xmFormWidgetClass, rc, NULL);
	sep = XmCreateScrolledList(okbtn, "Maps", NULL, 0);
	XtVaSetValues(sep,
		      XmNwidth, 100,
		      XmNvisibleItemCount, 10,
		      XmNleftAttachment, XmATTACH_FORM,
		      XmNrightAttachment,  XmATTACH_FORM,
		      XmNtopAttachment,    XmATTACH_FORM,
		      XmNbottomAttachment, XmATTACH_FORM,
		      NULL);

	if ( (dp = opendir("./maps")) != NULL )
	  {
	    while ( (dirp = readdir(dp)) != NULL ){
	      num = strlen(dirp->d_name);
	      if ((dirp->d_name[num-3]=='m') && (dirp->d_name[num-2]=='a') && (dirp->d_name[num-1]=='p'))
		XmListAddItem(sep, XmStringCreateLocalized(dirp->d_name), 0);
	    }
	  }
	XtManageChild(sep);
	XtAddCallback(sep, XmNbrowseSelectionCallback, MapListSelection, NULL);


	sep = XtVaCreateManagedWidget("button holder", xmFormWidgetClass, tform,
				      XmNnumColumns, 16,
				      XmNpacking, XmPACK_TIGHT,
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget, rc,
				      XmNbottomOffset, 15,
				      XmNleftAttachment, XmATTACH_FORM,
				      XmNleftOffset, 15,
				      XmNrightAttachment, XmATTACH_FORM,
				      XmNtopAttachment, XmATTACH_FORM,
				      NULL);


        for (i=0; i<NUM_COLORS; i++){
	  if (i>15) j=1;
	  buttons[i] = XtVaCreateManagedWidget(" ", xmDrawingAreaWidgetClass, sep,
                   XmNleftAttachment, (i%16)>0? XmATTACH_WIDGET : XmATTACH_FORM,
                   XmNleftWidget,     (i%16)>0? buttons[i-1] : NULL,
                   XmNtopAttachment,  j>0? XmATTACH_WIDGET : XmATTACH_FORM,
                   XmNtopWidget,      j>0? buttons[i-16] : NULL,
                   XmNbackground,     gpDisplayColors->GetColor(i),
                   XmNwidth,          20,
                   XmNheight,         20,
                   NULL);
	  XtAddEventHandler(buttons[i], ButtonReleaseMask, false, (XtEventHandler) SelectColormapEntry, (XtPointer) i);
        }




    }
    else {               
      UpdateColorDialog();
    }

    if (show) {
      XtManageChild(copane);
      XtManageChild(colorDialog);
    }
    if ((okbtn=XtNameToWidget(viewMenu, "button_1")))
      XtVaSetValues(okbtn, XmNset, show, NULL);
}



void create_previewDialog(bool isInit, bool show) {

  Widget widget;

  if ((!previewDialog) && (show))
    previewDialog = new dlgPreview(topLevel, &gColormap, &gGC, isInit, firstState->pane, curState->pane, show, firstState);

  if ( (widget = XtNameToWidget(viewMenu, "button_2")) != NULL )
    XtVaSetValues(widget, XmNset, show, NULL);

}



//
//
//  Parameters Dialog
//
//
/////////////////////////////////////////////////////////////////////////

void UpdateCoordStyle(short style, double xi, double xa, double yi, double ya){

    char     buf[32]="";
    double   xc, yc, xr, yr;

    bool bSwitchBackChanged = gbHasChanged;

    xc = (xa+xi)/2;
    xr = (xa-xi)/2;
    yc = (ya+yi)/2;
    yr = (ya-yi)/2;


    if (style==CS_MINMAX)
      {
      XtVaSetValues(coordStyleBtn, XmNlabelString, XmStringCreateLocalized("Min./Max."), NULL);

      XtVaSetValues(lblXmin, XmNlabelString, XmStringCreateLocalized("x center:"), NULL);
      XtVaSetValues(lblXmin, XmNheight, 30, NULL);
      XtVaSetValues(lblXmax, XmNlabelString, XmStringCreateLocalized("x radius:"), NULL);
      XtVaSetValues(lblXmax, XmNheight, 30, NULL);

      XtVaSetValues(lblYmin, XmNlabelString, XmStringCreateLocalized("y center:"), NULL);
      XtVaSetValues(lblYmin, XmNheight, 30, NULL);
      XtVaSetValues(lblYmax, XmNlabelString, XmStringCreateLocalized("y radius:"), NULL);
      XtVaSetValues(lblYmax, XmNheight, 30, NULL);

      sprintf(buf, "%.15f", xc);
      XtVaSetValues(xminBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", xr);
      XtVaSetValues(xmaxBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", yc);
      XtVaSetValues(yminBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", yr);
      XtVaSetValues(ymaxBox, XmNvalue, buf, NULL);

      giCoordDisplayStyle = CS_CTRRAD;
      }
    else
      {
      XtVaSetValues(coordStyleBtn, XmNlabelString, XmStringCreateLocalized("Cnt./Rad."), NULL);

      XtVaSetValues(lblXmin, XmNlabelString, XmStringCreateLocalized("x min: "), NULL);
      XtVaSetValues(lblXmin, XmNheight, 30, NULL);
      XtVaSetValues(lblXmax, XmNlabelString, XmStringCreateLocalized("x max: "), NULL);
      XtVaSetValues(lblXmax, XmNheight, 30, NULL);

      XtVaSetValues(lblYmin, XmNlabelString, XmStringCreateLocalized("y min: "), NULL);
      XtVaSetValues(lblYmin, XmNheight, 30, NULL);
      XtVaSetValues(lblYmax, XmNlabelString, XmStringCreateLocalized("y max: "), NULL);
      XtVaSetValues(lblYmax, XmNheight, 30, NULL);

      sprintf(buf, "%.15f", xi);
      XtVaSetValues(xminBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", xa);
      XtVaSetValues(xmaxBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", yi);
      XtVaSetValues(yminBox, XmNvalue, buf, NULL);
      sprintf(buf, "%.15f", ya);
      XtVaSetValues(ymaxBox, XmNvalue, buf, NULL);

      giCoordDisplayStyle = CS_MINMAX;
      }

    gbHasChanged = bSwitchBackChanged;
}

void ResetCoords(Widget dialog, XtPointer client, XtPointer call){
  //  resets values for xmin, xmax, ymin, ymax
  char *buf="";
  long   width = curState->lWidth, height = curState->lHeight;
  bool   bVertical = false;
  double wOh = (double) width/height;
  double hOw = (double) height/width;

  bool   bSwitchStylesBack = false, bUpdateCoords = false;
  double xi=0, xa=0, yi=0, ya=0, dtemp;

  if (width < height) bVertical = true;

  xi = (bVertical)? -2.0 : (-2.0*wOh);
  xa = (bVertical)?  2.0 : (2.0*wOh);
  yi = (bVertical)? (-2.0*hOw) : -2.0;
  ya = (bVertical)? (2.0*hOw)  :  2.0;


  XtVaGetValues(xminBox, XmNvalue, &buf, NULL);
  dtemp = atof(buf);
  if (dtemp!=xi) bUpdateCoords = true;
  XtVaGetValues(xmaxBox, XmNvalue, &buf, NULL);
  dtemp = atof(buf);
  if (dtemp!=xa) bUpdateCoords = true;
  XtVaGetValues(yminBox, XmNvalue, &buf, NULL);
  dtemp = atof(buf);
  if (dtemp!=yi) bUpdateCoords = true;
  XtVaGetValues(ymaxBox, XmNvalue, &buf, NULL);
  dtemp = atof(buf);
  if (dtemp!=ya) bUpdateCoords = true;

  if (!bUpdateCoords) return;

  if (giCoordDisplayStyle==CS_CTRRAD)
    {
      UpdateCoordStyle(CS_CTRRAD, xi, xa, yi, ya);
      bSwitchStylesBack = true;
    }


  sprintf(buf, "%.15f", xi);
  XtVaSetValues(xminBox, XmNvalue, buf, NULL);
  sprintf(buf, "%.15f", xa);
  XtVaSetValues(xmaxBox, XmNvalue, buf, NULL);
  sprintf(buf, "%.15f", yi);
  XtVaSetValues(yminBox, XmNvalue, buf, NULL);
  sprintf(buf, "%.15f", ya);
  XtVaSetValues(ymaxBox, XmNvalue, buf, NULL);


  if (bSwitchStylesBack)
    UpdateCoordStyle(CS_MINMAX, xi, xa, yi, ya);

}


void RefreshParameters(){
  //  fill all data in the parameters dialog box with what's in curState
    char    t[80];
    long iFunctionIndex;
    short top, vis;


    XtRemoveCallback(xmaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(ymaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);



    XtVaGetValues(funcList, XmNtopItemPosition, &top, XmNvisibleItemCount, &vis, NULL);
    iFunctionIndex = XmListItemPos(funcList, XmStringCreateLocalized(curState->function->label));
    XmListSelectPos(funcList, iFunctionIndex, false);
    if (iFunctionIndex < top)
        XmListSetPos(funcList, iFunctionIndex);
    else if (iFunctionIndex >= top + vis)
        XmListSetBottomPos(funcList, iFunctionIndex);



    if (giCoordDisplayStyle==CS_MINMAX)
        {
	sprintf(t, "%.15f", curState->dXmin);
	XmTextSetString(xminBox, t);
	sprintf(t, "%.15f", curState->dXmax);
	XmTextSetString(xmaxBox, t);
	sprintf(t, "%.15f", curState->dYmin);
	XmTextSetString(yminBox, t);
	sprintf(t, "%.15f", curState->dYmax);
	XmTextSetString(ymaxBox, t);
        }
    else
        {
	sprintf(t, "%.15f", (curState->dXmax + curState->dXmin)/2);
	XmTextSetString(xminBox, t);
	sprintf(t, "%.15f", (curState->dXmax - curState->dXmin)/2);
	XmTextSetString(xmaxBox, t);
	sprintf(t, "%.15f", (curState->dYmax + curState->dYmin)/2);
	XmTextSetString(yminBox, t);
	sprintf(t, "%.15f", (curState->dYmax - curState->dYmin)/2);
	XmTextSetString(ymaxBox, t);
        }
    sprintf(t, "%.15f", curState->function->parameter.a);
    XmTextSetString(aBox, t);
    sprintf(t, "%.15f", curState->function->parameter.b);
    XmTextSetString(bBox, t);
    sprintf(t, "%ld", curState->lMaxIterations);
    XmTextSetString(itersBox, t);
    sprintf(t, "%.3f", dZoomFactor);
    XmTextSetString(zoomBox, t);
    sprintf(t, "%ld", curState->lWidth);
    XmTextSetString(widthBox, t);
    sprintf(t, "%ld", curState->lHeight);
    XmTextSetString(heightBox, t);

    //  set color type
    if (curState->bUseColor)
        XtVaSetValues(XtNameToWidget(typeMenu, "button_2"), XmNset, true, NULL);
    else
        XtVaSetValues(XtNameToWidget(typeMenu, "button_2"), XmNset, false, NULL);

    //  set fractal type (julia/mandelbrot)
    TypeMenuSelect(aBox, (XtPointer) curState->type, 0);

    //  set global colormap
    gpDisplayColors = curState->eyemap;
    UpdateColorDialog();

    // reset callbacks
    XtAddCallback(xmaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(ymaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);
   
}



void SwitchCoordStyle(Widget w, XtPointer client, XtPointer call){
  XmString str;
  char *t="";
  short value;

  XtVaGetValues(w, XmNlabelString, &str, NULL);
  XmStringGetLtoR(str, XmFONTLIST_DEFAULT_TAG, &t);

  if (strcmp(t, "Min./Max.")==0)
    value = CS_CTRRAD;
  else
    value = CS_MINMAX;

  UpdateCoordStyle(value, curState->dXmin, curState->dXmax, curState->dYmin, curState->dYmax);
}



void ParameterEdited_BeforeChange(Widget w, XtPointer client, XtPointer callback){
  bool     KAset;
  char    *buf="";

  XtVaGetValues(keepaspect, XmNset, &KAset, NULL);

  giOldWidth = giOldHeight = -1;

  if ((w==widthBox) && (KAset)) {
    XtVaGetValues(widthBox, XmNvalue, &buf, NULL);
    giOldWidth = atoi(buf);
  }
  else if ((w==heightBox) && (KAset)) {
    XtVaGetValues(heightBox, XmNvalue, &buf, NULL);
    giOldHeight = atoi(buf);
  }

}


void ParameterEdited(Widget w, XtPointer client, XtPointer callback){
  //  now we know we should create a new fractal when "Iterate" is activated
  char     *buf="", *b2="";
  bool     KAset;
  long     f, a, b;
  double   dratio, dratioorig, da;

  gbHasChanged = true;


  XtVaGetValues(keepaspect, XmNset, &KAset, NULL);

  if ((w==xmaxBox) && (giCoordDisplayStyle==CS_CTRRAD) && (KAset)) {
    XtRemoveCallback(xmaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(ymaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);

    XtVaGetValues(xmaxBox, XmNvalue, &buf, NULL);
    XtVaGetValues(ymaxBox, XmNvalue, &b2, NULL);

    dratioorig = ((curState->dXmax-curState->dXmin)/2) / ((curState->dYmax-curState->dYmin)/2);
    da = atof(buf);
    dratio = atof(buf) / atof(b2);

    if (dratio!=dratioorig) {
      sprintf(buf, "%.15f", da/dratioorig);
      XtVaSetValues(ymaxBox, XmNvalue, buf, NULL);
    }

    XtAddCallback(xmaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(ymaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);        
  }
  if ((w==ymaxBox) && (giCoordDisplayStyle==CS_CTRRAD) && (KAset)) {
    XtRemoveCallback(xmaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(ymaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
      
    XtVaGetValues(xmaxBox, XmNvalue, &buf, NULL);
    XtVaGetValues(ymaxBox, XmNvalue, &b2, NULL);

    dratioorig = ((curState->dXmax-curState->dXmin)/2) / ((curState->dYmax-curState->dYmin)/2);
    da = atof(b2);
    dratio = atof(buf) / atof(b2);

    if (dratio!=dratioorig) {
      sprintf(buf, "%.15f", da*dratioorig);
      XtVaSetValues(xmaxBox, XmNvalue, buf, NULL);
    }
	    
    XtAddCallback(xmaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(ymaxBox, XmNvalueChangedCallback, ParameterEdited, NULL);
  }


  // if change was made in width or height boxes, and aspect ratio is set,
  //  set the other one (height or width) to the correct, adjusted value
  if ((w==widthBox) && (KAset) && (giOldWidth>0)) {

    //  remove the callbacks to prevent crap values, and infinite looping
    XtRemoveCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);

    XtVaGetValues(widthBox, XmNvalue, &buf, NULL);
    XtVaGetValues(heightBox, XmNvalue, &b2, NULL);
    a = atoi(buf);
    b = atoi(b2);

    dratioorig = (double) ((double) b / (double) giOldWidth);
    f =  (long) (a * dratioorig);

    if (f!=b) {
      sprintf(buf, "%ld", f);
      XtVaSetValues(heightBox, XmNvalue, buf, NULL);
    }

    XtAddCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    
    giOldWidth  = -1;
    giOldHeight = -1;
  }

  if ((w==heightBox) && (KAset) && (giOldHeight>0)) {
    //  remove the callbacks to prevent crap values, and infinite looping
    XtRemoveCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtRemoveCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);

    XtVaGetValues(widthBox, XmNvalue, &buf, NULL);
    XtVaGetValues(heightBox, XmNvalue, &b2, NULL);
    a = atoi(buf);
    b = atoi(b2);

    dratioorig = (double) ((double) a / (double) giOldHeight);
    f =  (long) (b * dratioorig);

    if (f!=a) {
      sprintf(buf, "%ld", f);
      XtVaSetValues(widthBox, XmNvalue, buf, NULL);
    }

    XtAddCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);

    giOldWidth  = -1;
    giOldHeight = -1;
  }
}



void create_paramDialog(bool show){
  Widget  lc, widget, colorbw, admin;
  short   i;
  XmStringTable str_list;
  char t[80];
  Arg args[7];

  if (!paramDialog) {

    paramDialog = XtVaCreatePopupShell("Parameters", xmDialogShellWidgetClass, topLevel,
				       XmNx,    505,       XmNy,     0,
				       XmNwidth,           250,
				       XmNresizePolicy,    XmRESIZE_NONE,
				       XmNdeleteResponse,  XmUNMAP,
				       NULL);
    XtAddCallback(paramDialog, XmNpopdownCallback, close_dialog, (XtPointer) paramDialog);
    XtAddCallback(paramDialog, XmNdestroyCallback, close_dialog, (XtPointer) paramDialog);

    pane = XtVaCreateWidget("layoutmanager", xmPanedWindowWidgetClass, paramDialog,
			    XmNsashWidth,  1,
			    XmNsashHeight, 1,
			    NULL);


    admin  = XtVaCreateManagedWidget("bottom", xmFormWidgetClass, pane,
				     XmNnumColumns,              1,
				     XmNorientation,             XmVERTICAL,
				     XmNpacking,                 XmPACK_TIGHT,
				     XmNisAligned,               true,
				     XmNentryVerticalAlignment,  XmALIGNMENT_CONTENTS_BOTTOM,
				     XmNleftAttachment,          XmATTACH_FORM,
				     XmNbottomAttachment,        XmATTACH_FORM,
				     XmNtopAttachment,           XmATTACH_FORM,
				     XmNfractionBase,            5,
				     NULL);

    widget = XtVaCreateManagedWidget("Iterate", xmPushButtonGadgetClass, admin,
				     XmNbottomAttachment,    XmATTACH_FORM,
				     XmNleftAttachment,      XmATTACH_POSITION,
				     XmNleftPosition,        0,
				     XmNrightAttachment,     XmATTACH_POSITION,
				     XmNrightPosition,       2,
				     XmNshowAsDefault,       true,
				     XmNdefaultButtonShadowThickness,    1,
				     NULL);
    XtAddCallback(widget, XmNactivateCallback, IterateButtonPressed, NULL);

    widget = XtVaCreateManagedWidget("Hide", xmPushButtonGadgetClass, admin,
				     XmNbottomAttachment,    XmATTACH_FORM,
				     XmNleftAttachment,      XmATTACH_POSITION,
				     XmNleftPosition,        3,
				     XmNrightAttachment,     XmATTACH_POSITION,
				     XmNrightPosition,       5,
				     XmNdefaultButtonShadowThickness,    1,
				     NULL);
    XtAddCallback(widget, XmNactivateCallback, close_dialog, (XtPointer) paramDialog);
    
    
    colorbw = XtVaCreateManagedWidget("colorbw1", xmRowColumnWidgetClass, admin,
				      XmNnumColumns,       1,
				      XmNorientation,      XmVERTICAL,
				      XmNentryClass,       xmToggleButtonWidgetClass,
				      XmNpacking,          XmPACK_COLUMN,
				      XmNradioBehavior,    false,
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget,     widget,
				      XmNleftAttachment,   XmATTACH_FORM,
				      XmNrightAttachment,  XmATTACH_FORM,
				      XmNheight,           30,
				      NULL);
    keepaspect = XtVaCreateManagedWidget("Maintain aspect ratio", xmToggleButtonWidgetClass, colorbw,
					 XmNtopAttachment,   XmATTACH_FORM,
					 XmNleftAttachment,  XmATTACH_FORM,
					 XmNindicatorType,   XmN_OF_MANY,
					 XmNset,             true,
					 NULL);



    //  zoom factor label and textbox
    lc  = XtVaCreateManagedWidget("Zoom factor ( >1 ): ", xmLabelWidgetClass, admin,
				  XmNleftAttachment,    XmATTACH_FORM,
				  XmNbottomAttachment,  XmATTACH_WIDGET,
				  XmNbottomWidget,      colorbw,
				  XmNheight,            30,
				  NULL);
    zoomBox = XtVaCreateManagedWidget("zoombox", xmTextFieldWidgetClass, admin,
				      XmNvalue,            "",
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget,     colorbw,
				      XmNrightAttachment,  XmATTACH_FORM,
				      XmNleftAttachment,   XmATTACH_WIDGET,
				      XmNleftWidget,       lc,
				      XmNwidth,            50,
				      XmNheight,           30,
				      XmNforeground,       blackpixel,
				      XmNbackground,       whitepixel,
				      NULL);

    //  width and height labels and boxes 
    widthBox = XtVaCreateManagedWidget("widthbox", xmTextFieldWidgetClass, admin,
				       XmNvalue,            "",
				       XmNbottomAttachment, XmATTACH_WIDGET,
				       XmNbottomWidget,     lc,
				       XmNbottomOffset,     15,
				       XmNleftAttachment,   XmATTACH_FORM,
				       XmNwidth,            55,    
				       XmNheight,           30,
				       XmNbackground,       whitepixel,
				       XmNforeground,       blackpixel,
				       NULL);
    heightBox = XtVaCreateManagedWidget("heightbox", xmTextFieldWidgetClass, admin,
					XmNvalue,            "",
					XmNbottomAttachment, XmATTACH_WIDGET,
					XmNbottomWidget,     zoomBox,
					XmNbottomOffset,     15,
					XmNrightAttachment,  XmATTACH_FORM,
					XmNwidth,            55,    
					XmNheight,           30,
					XmNforeground,       blackpixel,
					XmNbackground,       whitepixel,
					NULL);
    lc = XtVaCreateManagedWidget("  Width", xmLabelWidgetClass, admin,
				 XmNleftAttachment,    XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_WIDGET,
				 XmNbottomWidget,      widthBox,
				 XmNheight,            15,
				 NULL);
    widget = XtVaCreateManagedWidget("Height ", xmLabelWidgetClass, admin,
				     XmNbottomAttachment,  XmATTACH_WIDGET,
				     XmNbottomWidget,      heightBox,
				     XmNrightAttachment,   XmATTACH_FORM,
				     XmNheight,            15,
				     NULL);
    widget = XtVaCreateManagedWidget("(pixels)", xmLabelWidgetClass, admin,
				     XmNleftAttachment,    XmATTACH_WIDGET,
				     XmNleftWidget,        lc,
				     XmNrightAttachment,   XmATTACH_WIDGET,
				     XmNrightWidget,       widget,
				     XmNbottomAttachment,  XmATTACH_WIDGET,
				     XmNbottomWidget,      widthBox,
				     XmNheight,            15,
				     NULL);


    //  number of iterations label and textbox
    lc = XtVaCreateManagedWidget("Max # of Iterations:", xmLabelWidgetClass, admin,
				 XmNleftAttachment,    XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_WIDGET,
				 XmNbottomOffset,      15,
				 XmNbottomWidget,      lc,
				 XmNheight,            30,
				 NULL);
    itersBox = XtVaCreateManagedWidget("itersbox", xmTextFieldWidgetClass, admin,
				       XmNvalue,            "",
				       XmNbottomAttachment, XmATTACH_WIDGET,
				       XmNbottomWidget,     widget,
				       XmNbottomOffset,     15,
				       XmNrightAttachment,  XmATTACH_FORM,
				       XmNwidth,            65,    
				       XmNheight,           30,
				       XmNforeground,       blackpixel,
				       XmNbackground,       whitepixel,
				       NULL);

    aBox = XtVaCreateManagedWidget("complex_a", xmTextFieldWidgetClass, admin,
				   XmNvalue,            "",
				   XmNbottomAttachment, XmATTACH_WIDGET,
				   XmNbottomWidget,     lc,
				   XmNbottomOffset,     15,
				   XmNleftAttachment,   XmATTACH_FORM,
				   XmNwidth,            90,
				   XmNheight,           30,
				   XmNforeground,       blackpixel,
				   XmNbackground,       whitepixel,
				   NULL);
    bBox = XtVaCreateManagedWidget("complex_b", xmTextFieldWidgetClass, admin,
				   XmNvalue,            "",
				   XmNbottomAttachment, XmATTACH_WIDGET,
				   XmNbottomOffset,     15,
				   XmNbottomWidget,     itersBox,
				   XmNrightAttachment,  XmATTACH_FORM,
				   XmNwidth,            90,
				   XmNheight,           30,
				   XmNforeground,       blackpixel,
				   XmNbackground,       whitepixel,
				   NULL);

    
    //  complex parameter labels and textboxes
    lc = XtVaCreateManagedWidget("Complex parameter c (a+bi):", xmLabelWidgetClass, admin,
				 XmNleftAttachment,    XmATTACH_FORM,
				 XmNrightAttachment,   XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_WIDGET,
				 XmNbottomWidget,      bBox,
				 XmNheight,            15,
				 XmNalignment,         XmALIGNMENT_CENTER,
				 NULL);
    
    if (giFractalType==MANDELBROT) {
      XtVaSetValues(aBox, XtVaTypedArg, XmNbackground, XmRString, "gray", strlen("blck"+1),
		    XmNsensitive, false,
		    NULL);
      XtVaSetValues(bBox, XtVaTypedArg, XmNbackground, XmRString, "gray", strlen("blck"+1),
		    XmNsensitive, false,
		    NULL);
    }
    

    
    coordStyleBtn = XtVaCreateManagedWidget("Cnt./Rad.", xmPushButtonGadgetClass, admin,
					    XmNbottomAttachment,    XmATTACH_WIDGET,
					    XmNbottomWidget,        lc,
					    XmNbottomOffset,        15,
					    XmNleftAttachment,      XmATTACH_POSITION,
					    XmNleftPosition,        0,
					    XmNrightAttachment,     XmATTACH_POSITION,
					    XmNrightPosition,       2,
					    NULL);
    XtAddCallback(coordStyleBtn, XmNactivateCallback, SwitchCoordStyle, NULL);
    
    widget = XtVaCreateManagedWidget("Reset Coords", xmPushButtonGadgetClass, admin,
				     XmNbottomAttachment,    XmATTACH_WIDGET,
				     XmNbottomWidget,        lc,
				     XmNbottomOffset,        15,
				     XmNleftAttachment,      XmATTACH_POSITION,
				     XmNleftPosition,        3,
				     XmNrightAttachment,     XmATTACH_POSITION,
				     XmNrightPosition,       5,
				     NULL);
    XtAddCallback(widget, XmNactivateCallback, ResetCoords, NULL);
    


    //  ymax label and textbox
    lblYmax  = XtVaCreateManagedWidget("y max: ", xmLabelWidgetClass, admin,
				       XmNleftAttachment,    XmATTACH_FORM,
				       XmNbottomAttachment,  XmATTACH_WIDGET,
				       XmNbottomWidget,      coordStyleBtn,
				       XmNheight,            30,
				       NULL);
    ymaxBox = XtVaCreateManagedWidget("ymaxbox", xmTextFieldWidgetClass, admin,
				      XmNvalue,            "999",
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget,     widget,
				      XmNleftAttachment,   XmATTACH_WIDGET,
				      XmNleftWidget,       lblYmax,
				      XmNrightAttachment,  XmATTACH_FORM,
				      XmNwidth,            135,
				      XmNheight,           30,
				      XmNbackground,       whitepixel,
				      XmNforeground,       blackpixel,
				      NULL);

    //  ymin label and textbox
    lblYmin  = XtVaCreateManagedWidget("y min: ", xmLabelWidgetClass, admin,
				       XmNleftAttachment,    XmATTACH_FORM,
				       XmNbottomAttachment,  XmATTACH_WIDGET,
				       XmNbottomWidget,      lblYmax,
				       XmNheight,            30,
				       NULL);
    yminBox = XtVaCreateManagedWidget("yminbox", xmTextFieldWidgetClass, admin,
				      XmNvalue,            "999",
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget,     ymaxBox,
				      XmNrightAttachment,  XmATTACH_FORM,
				      XmNleftAttachment,   XmATTACH_WIDGET,
				      XmNleftWidget,       lblYmin,
				      XmNwidth,            135,
				      XmNheight,           30,
				      XmNbackground,       whitepixel,
				      XmNforeground,       blackpixel,
				      NULL);

    //  xmax label and textbox
    lblXmax  = XtVaCreateManagedWidget("x max: ", xmLabelWidgetClass, admin,
				       XmNleftAttachment,    XmATTACH_FORM,
				       XmNbottomAttachment,  XmATTACH_WIDGET,
				       XmNbottomWidget,      lblYmin,
				       XmNheight,            30,
				       NULL);
    xmaxBox = XtVaCreateManagedWidget("xmaxbox", xmTextFieldWidgetClass, admin,
				      XmNvalue,            "999",
				      XmNbottomAttachment, XmATTACH_WIDGET,
				      XmNbottomWidget,     yminBox,
				      XmNrightAttachment,  XmATTACH_FORM,
				      XmNleftAttachment,   XmATTACH_WIDGET,
				      XmNleftWidget,       lblXmax,
				      XmNwidth,            135,
				      XmNheight,           30,
				      XmNbackground,       whitepixel,
				      XmNforeground,       blackpixel,
				      NULL);

    //  xmin label and textbox
    lblXmin  = XtVaCreateManagedWidget("x min: ", xmLabelWidgetClass, admin,
				       XmNleftAttachment,    XmATTACH_FORM,
				       XmNbottomAttachment,  XmATTACH_WIDGET,
				       XmNbottomWidget,      lblXmax,
				       XmNheight,            30,
				       NULL);
    xminBox = XtVaCreateManagedWidget("xminbox", xmTextFieldWidgetClass, admin,
				      XmNvalue,             "999",
				      XmNrightAttachment,   XmATTACH_FORM,
				      XmNbottomAttachment,  XmATTACH_WIDGET,
				      XmNbottomWidget,      xmaxBox,
				      XmNleftAttachment,    XmATTACH_WIDGET,
				      XmNleftWidget,        lblXmin,
				      XmNwidth,             135,
				      XmNheight,            30,
				      XmNbackground,        whitepixel,
				      XmNforeground,        blackpixel,
				      NULL);

   
    str_list = (XmStringTable) XtMalloc(giNumFuncs * sizeof(XmString));
    for (i=0; i<giNumFuncs; i++)
	str_list[i] = XmStringCreateLocalized(strcpy(t, function_lbls[i]));

    XtSetArg(args[0], XmNtopAttachment,       XmATTACH_FORM);
    XtSetArg(args[1], XmNleftAttachment,      XmATTACH_FORM);
    XtSetArg(args[2], XmNrightAttachment,     XmATTACH_FORM);
    XtSetArg(args[3], XmNbottomAttachment,    XmATTACH_WIDGET);
    XtSetArg(args[4], XmNbottomWidget,        xminBox);
    XtSetArg(args[5], XmNitemCount,           giNumFuncs);
    XtSetArg(args[6], XmNitems,               str_list);
    XtSetArg(args[7], XmNvisibleItemCount,    4);

    funcList = XmCreateScrolledList(admin, "funcList", args, 8);
    XtManageChild(funcList);

    XmListSelectPos(funcList, 0, false);

    
    for (i=0; i<giNumFuncs; i++)
      XmStringFree(str_list[i]);
    XtFree((char *) str_list);

    // for when a parameter is changed
    XtAddCallback(funcList,  XmNbrowseSelectionCallback, ParameterEdited, NULL);
    XtAddCallback(xminBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(xmaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(yminBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(ymaxBox,   XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(itersBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(aBox,      XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(bBox,      XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(widthBox,  XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(heightBox, XmNvalueChangedCallback, ParameterEdited, NULL);
    XtAddCallback(widthBox,  XmNmodifyVerifyCallback, ParameterEdited_BeforeChange, NULL);
    XtAddCallback(heightBox, XmNmodifyVerifyCallback, ParameterEdited_BeforeChange, NULL);


    // if the user presses "enter" in one of the text fields, iterate the fractal
    XtAddCallback(xminBox,   XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(xmaxBox,   XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(yminBox,   XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(ymaxBox,   XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(itersBox,  XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(aBox,      XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(bBox,      XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(widthBox,  XmNactivateCallback, IterateButtonPressed, NULL);
    XtAddCallback(heightBox, XmNactivateCallback, IterateButtonPressed, NULL);


  }
  
  if ( show )
    {
      XtManageChild(pane);
      XtManageChild(paramDialog);
    }

  if ((widget=XtNameToWidget(viewMenu, "button_0")))
    XtVaSetValues(widget, XmNset, show, NULL);
}




short LoadAndExport(char *inputFile, short type){
  
  curState = (XState *) new State(inputFile);
  
  gpDisplayColors = new EyeMap(curState->type, inputFile, 0, 0, &(curState->bUseColor));
  curState->eyemap = gpDisplayColors;

#ifdef ENABLE_JPEG
  image_buffer = (JSAMPLE *) XtMalloc(curState->lWidth * curState->lHeight * 3 * sizeof(unsigned char));
#else
  image_buffer = (long *) XtMalloc(curState->lWidth * curState->lHeight * 3 * sizeof(long));
#endif


  if (type==CF_JPEG)
    {
      ExportJPEG(NULL, export_filename, NULL);
    }
  else
    {
      //      ExportPPM(NULL, NULL, NULL);

          CreateFractal(CF_PPM);


    //     write pixel_map to file
    if ( ( exportFile = fopen( export_filename, "w" ) ) != NULL ) {
      fprintf( exportFile, "P6\n%ld %ld\n%d\n", curState->lWidth, curState->lHeight, 255);
     
      for( long i=0; i<3*curState->lWidth * curState->lHeight; i++ )
	fprintf( exportFile, "%c ", (char) image_buffer[i] );

      fclose(exportFile);
      printf("Export successful.  Exiting...\n\n");
    }
    else
      {
	printf("ERROR:  Cannot open file %s for writing\n", export_filename);
	return -1;
	}
    }
  
  return 0;
}




void signal_handler(int signo){
  /*  signal handler  */
  switch (signo){
  case SIGINT:
    printf("ERROR - Interrupt!\n\n\n");
    byebye(NULL, NULL, NULL);
    break;
  case SIGSEGV:
    printf("ERROR - Seg Fault!\nPlease report all bugs to %s\n\n\n", EMAIL);
    byebye(NULL, NULL, NULL);
    break;
  }
}


void init() {

  gpDisplayColors = 0;
  paramDialog = 0;
  aboutDialog = 0;
  firstState = lastState = curState = 0;

  options.bareMode = false;
  options.verbose = false;
}



void printHelp(){

  printf("EyeFract %s\n\n", VERSION);
  printf("eyefract [-h|-?|--help] [--version] [-b|--bare] [-m|--map] [-l|--load [-o|--output]] [--version]\n");

  printf("  -?  or  -h  or  --help\n");
  printf("    Display this message\n\n");

  printf("  --version\n");
  printf("    Print version info and exit\n\n");

  printf("  -b  or  --bare\n");
  printf("    Only display the main EyeFract window.  Hide the parameters,\n");
  printf("    preview and colormap dialogs.\n\n");

  printf("  -m  or  --map <filename>\n");
  printf("    Bypass the default colormap, and load <filename>.\n");
  printf("    If <filename> cannot be found, the default map is loaded.\n");
  printf("    If that file (default.map) cannot be found, EyeFract dies.\n\n");

  printf("  -l  or  --load <filename>\n");
  printf("    Load the specified filename as the initial state.  The colormap\n");
  printf("    entries will override any specified by -m.\n\n");

  printf("  -o  or  --output <filename>\n");
  printf("    Used with -l, output the file specified by -l to a .ppm file.\n");

}




int main(int argc, char **argv){
    Widget   main_w, menubar, widget;
    char     *mapFilename="maps/default.map";
    char     *loadFilename=0;
    short    k, type=CF_PPM, len;
    XmString load, save, qui, ctrlq, ctrll, st, ctrls, tp, nine, ten;

    XtAppContext app;
    XmFileSelectionBoxCallbackStruct cbs;


    init();

    for (k=1; k<argc; k++){

      if (!strcmp(argv[k], "--version")){
	printf("EyeFract %s\n", VERSION);
	return 0;
      }

        if ((!strcmp(argv[k], "-m")) || (!strcmp(argv[k], "--map"))){
            if (argc>k+1)
                mapFilename = argv[++k];
            else
                printf("Invalid usage:  eyefract -m <map_filename>\nUsing default colormap\n");
        }

        if ((!strcmp(argv[k], "-?")) || (!strcmp(argv[k], "-h")) || (!strcmp(argv[k], "--help"))){
	  printHelp();
	  return 0;
        }

        if ((!strcmp(argv[k], "-b")) || (!strcmp(argv[k], "--bare")))
            options.bareMode = true;

        if ((!strcmp(argv[k], "-l")) || (!strcmp(argv[k], "--load"))){
            if (argc>k+1)
                loadFilename = argv[++k];
            else
                {
                printf("Invalid usage:  eyefract -l <state_filename>.  Exiting...\n\n");
                exit(0);
                }
        }


        if ((!strcmp(argv[k], "-o")) || (!strcmp(argv[k], "--output"))){
            if (argc>k+1)
                export_filename = argv[++k];
            else
                {
                printf("Invalid usage:  eyefract -o <target_filename>.  Exiting...\n\n");
                exit(1);
                }
        }

    } //for (reading command line args)

    if (export_filename)
        {
        if (!loadFilename)
            {
            printf("ERROR:  Need input filename (-l option) to use export (-o) from command line\nExiting...\n\n");
            exit(1);
            }

	len = strlen(export_filename);


#ifdef ENABLE_JPEG
	if ((export_filename[len-3]=='j') && (export_filename[len-2]=='p') && (export_filename[len-1]=='g'))
	  type = CF_JPEG;
#endif
	if ((export_filename[len-3]=='p') && (export_filename[len-2]=='p') && (export_filename[len-1]=='m'))
	  type = CF_PPM;

        /*  we have a load filename and an export-to filename  */
        exit( LoadAndExport(loadFilename, type) );
        }


    /*  so we have an escape  */
#ifdef EYESIGSET
    sigset(SIGINT, signal_handler);
    sigset(SIGSEGV, signal_handler);
#elif defined(EYESIGNAL)
    signal(SIGINT, signal_handler);
    signal(SIGSEGV, signal_handler);
#endif

    topLevel = XtVaAppInitialize(&app, "EyeFract", NULL, 0, &argc, argv, NULL, NULL);

    main_w = XtVaCreateManagedWidget("mw", xmMainWindowWidgetClass, topLevel,
                    XmNwidth,    DEFAULT_WIDTH+50,
                    XmNheight,   DEFAULT_HEIGHT+75,
		    XmNx,        0,
		    XmNy,        0,
                    XmNcommandWindowLocation, XmCOMMAND_BELOW_WORKSPACE,
                    NULL);

    /*  menubar  */
    st   = XmStringCreateLocalized("File");
    tp   = XmStringCreateLocalized("State");
    save = XmStringCreateLocalized("View");
    load = XmStringCreateLocalized("Help");
    menubar = XmVaCreateSimpleMenuBar (main_w, "menu",
        XmVaCASCADEBUTTON, st,   'F',
        XmVaCASCADEBUTTON, tp,   'S',
        XmVaCASCADEBUTTON, save, 'V',
        XmVaCASCADEBUTTON, load, 'H',
        NULL);
    XmStringFree(st);
    XmStringFree(load);
    XmStringFree(save);
    XmStringFree(tp);

    /*  file menu  */
    load  = XmStringCreateLocalized("Load state...");
    save  = XmStringCreateLocalized("Save state...");
    st    = XmStringCreateLocalized("Import colormap...");
    qui   = XmStringCreateLocalized("Export colormap...");
#ifdef ENABLE_JPEG
    nine  = XmStringCreateLocalized("Export JPEG...");
#endif
    ten   = XmStringCreateLocalized("Export PPM...");
    tp    = XmStringCreateLocalized("Quit");
    ctrll = XmStringCreateLocalized("Ctrl+L");
    ctrls = XmStringCreateLocalized("Ctrl+S");
    ctrlq = XmStringCreateLocalized("Ctrl+Q");
    XmVaCreateSimplePulldownMenu(menubar, "filemenu", 0, StateMenuSelect,
        XmVaPUSHBUTTON, load, 'L', "Ctrl<Key>L", ctrll,
        XmVaPUSHBUTTON, save, 'S', "Ctrl<Key>S", ctrls,
        XmVaSEPARATOR,
        XmVaPUSHBUTTON, st,   'I', NULL, NULL,
        XmVaPUSHBUTTON, qui,  'E', NULL, NULL,
        XmVaSEPARATOR,
#ifdef ENABLE_JPEG
        XmVaPUSHBUTTON, nine, 'J', NULL, NULL,
#endif
        XmVaPUSHBUTTON, ten,  'P', NULL, NULL,
        XmVaSEPARATOR,
        XmVaPUSHBUTTON, tp,   'Q', "Ctrl<Key>Q", ctrlq,
        NULL);
    XmStringFree(load);
    XmStringFree(save);
#ifdef ENABLE_JPEG
    XmStringFree(nine);
#endif
    XmStringFree(ten);
    XmStringFree(qui);
    XmStringFree(tp);
    XmStringFree(st);
    XmStringFree(ctrll);
    XmStringFree(ctrls);
    XmStringFree(ctrlq);

    /*  state menu  */
    save  = XmStringCreateLocalized("Julia");
    qui   = XmStringCreateLocalized("Mandelbrot");
    load  = XmStringCreateLocalized("Use Color");
    typeMenu = XmVaCreateSimplePulldownMenu(menubar, "statemenu", 1, TypeMenuSelect,
        XmVaRADIOBUTTON, save, 'J', NULL, NULL,
        XmVaRADIOBUTTON, qui,  'M', NULL, NULL,
        XmVaSEPARATOR,
        XmVaRADIOBUTTON, load, 'C', NULL, NULL,
        NULL);
    XmStringFree(save);
    XmStringFree(load);
    XmStringFree(qui);


    save  = XmStringCreateLocalized("Fractal Parameters");
    qui   = XmStringCreateLocalized("Colormap");
    load  = XmStringCreateLocalized("Preview Pane");
    viewMenu = XmVaCreateSimplePulldownMenu(menubar, "viewmenu", 2, ViewMenuSelect,
        XmVaRADIOBUTTON, save, 'F', NULL, NULL,
        XmVaRADIOBUTTON, qui,  'C', NULL, NULL,
        XmVaRADIOBUTTON, load, 'P', NULL, NULL,
        NULL);
    XmStringFree(save);
    XmStringFree(load);
    XmStringFree(qui);


    load = XmStringCreateLocalized("About EyeFract...");
    XmVaCreateSimplePulldownMenu(menubar, "helpmenu", 3, HelpMenuSelect,
         XmVaPUSHBUTTON, load, 'A', NULL, NULL,
         NULL);
    XmStringFree(load);

    
    widget = XtVaCreateManagedWidget("      ", xmLabelGadgetClass, menubar, NULL);
    widget = XtVaCreateManagedWidget("   <-   ", xmPushButtonWidgetClass, menubar, NULL);
    XtAddCallback(widget, XmNactivateCallback, GoToPrev, NULL);
    widget = XtVaCreateManagedWidget("   ->   ", xmPushButtonWidgetClass, menubar, NULL);
    XtAddCallback(widget, XmNactivateCallback, GoToNext, NULL);
    XtManageChild(menubar);


    /*  the scrolled window  */
    widget = XtVaCreateManagedWidget("sw", xmScrolledWindowWidgetClass, main_w,
                XmNscrollingPolicy,  XmAUTOMATIC,
                XmNincrement,        10,
                NULL);


    sComma = XmStringCreateSimple(", ");
    sOpenPar = XmStringCreateSimple("(");
    sClosePar = XmStringCreateSimple(")");
    nine = XmStringConcat(XmStringCreateSimple("EyeFract "), XmStringCreateSimple(VERSION));
    messageBar = XtVaCreateManagedWidget("messagebar", xmLabelWidgetClass,
        main_w,
        XmNlabelString, nine,
        XmNalignment,   XmALIGNMENT_BEGINNING,
        NULL);
    XmStringFree(nine);

    XmMainWindowSetAreas(main_w, menubar, messageBar, NULL, NULL, widget);
  
    XtRealizeWidget(topLevel);
    gpDisplay   = XtDisplay(topLevel);
    gWindow     = XtWindow(topLevel); 
    gColormap   = DefaultColormapOfScreen(XtScreen(topLevel));
    gGC         = XCreateGC(gpDisplay, gWindow, 0, NULL);
    whitepixel  = WhitePixelOfScreen(XtScreen(topLevel));
    blackpixel  = BlackPixelOfScreen(XtScreen(topLevel));

    if (strcmp(mapFilename, "maps/default.map")==0)
      printf("Loading colormap %s...", mapFilename);

    cbs.value = XmStringCreateLocalized(mapFilename);
    ImportColormap(NULL, NULL, &cbs);

    while (!gpDisplayColors) {

      if (strcmp(mapFilename, "maps/default.map")==0) {
	printf("ERROR: Default colormap file not found!!\n\n");
	return -1;
      }

      printf("ERROR: Colormap file %s not found!\nTrying default colormap...", mapFilename);
      strcpy(mapFilename, "maps/default.map");
      cbs.value = XmStringCreateLocalized(mapFilename);
      ImportColormap(NULL, NULL, &cbs);
    }
    printf("\n");
   
    /* where the fractal is to be drawn  */
    daCanvas = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, widget,
                XtVaTypedArg, XmNbackground, XmRString, "white", strlen("black"+1),
                XmNwidth,           DEFAULT_WIDTH,
                XmNheight,          DEFAULT_HEIGHT,
                XmNresizePolicy,    XmRESIZE_ANY,
                NULL);
    XtAddEventHandler(daCanvas, ExposureMask, false, (XtEventHandler) redraw, NULL);
    XtAddCallback(daCanvas, XmNresizeCallback, (XtCallbackProc) redraw, NULL);



    if ( (widget = XtNameToWidget(typeMenu, "button_0")) != NULL )
        XtVaSetValues(widget, XmNset, false, NULL);
    if ( (widget = XtNameToWidget(typeMenu, "button_1")) != NULL )
        XtVaSetValues(widget, XmNset, true, NULL);
    XtVaSetValues(XtNameToWidget(typeMenu, "button_2"), XmNset, true, NULL);


    create_paramDialog(!options.bareMode);
    if ( (widget = XtNameToWidget(viewMenu, "button_0")) != NULL )
        XtVaSetValues(widget, XmNset, !options.bareMode, NULL);

    if (loadFilename)
        {
        printf("Loading state %s...\n", loadFilename);
        cbs.value = XmStringCreateLocalized(loadFilename);

        if (strcmp(mapFilename, "maps/default.map")!=0)
            printf("Warning:  State info will override colormap selection\n");
            
        load_state(NULL, NULL, &cbs);
        }
    else
        {
	NewState(-2.0, 2.0, -2.0, 2.0, DEFAULT_WIDTH, DEFAULT_HEIGHT, true, 100, DEFAULT_TYPE, -.39054, -.58679);
	CreateFractal(CF_NORMAL);
        }


    XtAppMainLoop(app);

    return 0;
}
