#ifndef EYEMAP_H
#define EYEMAP_H


#include "common.h"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>

extern bool isValueOK(char *value, const char *name);

class EyeMap {

 public:
  XColor    colors[NUM_COLORS];
  Display  *gpDisplay;
  Colormap  gColormap;

  EyeMap(char *filename, Display *dpy, Colormap *cmap);
  EyeMap(short type, char *filename, Display *dpy, Colormap *cmap, bool *bUseColor);
  EyeMap(Display *dpy, Colormap *cmap, XColor *cols);
  ~EyeMap();


  void SetEntry(short index, XColor value);
  void StoreColor(short index, XColor *saveme);
  void UpdateEntry(short index, short whichComponent, long value);
  int  WriteToFile(char *filename);

  inline XColor GetXColor(long n) { return colors[n % NUM_COLORS]; }
  inline long GetColor(long n)  { return colors[n % NUM_COLORS].pixel; }
  inline long GetRed(long n)    { return colors[n % NUM_COLORS].red;   }
  inline long GetGreen(long n)  { return colors[n % NUM_COLORS].green; }
  inline long GetBlue(long n)   { return colors[n % NUM_COLORS].blue ; }

  inline void SetRed(short index, long value)   { colors[index].red   = value; }
  inline void SetGreen(short index, long value) { colors[index].green = value; }
  inline void SetBlue(short index, long value)  { colors[index].blue  = value; }

};


#endif
