#ifndef PANE_H
#define PANE_H

#include "common.h"

#include <stdio.h>

#include <math.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>
#include <Xm/DialogS.h>
#include <Xm/DrawingA.h>

//
//
//  HERE!!! ANOTHER OPTION -- THUMBNAIL_SIZE
//
//
#define THUMBNAIL_SIZE      100
#define THUMBNAIL_PADDING   8
#define THUMBNAIL_SPACING   4


extern void GoToState(short id);

class Pane {
 public:

  Pane   *next, *prev;
  Widget  widget;
  Pixmap  image;
  short   image_width, image_height;
  short   id;
  double  widthRatio, heightRatio;

  Screen  *gpScreen;
  Display *gpDisplay;
  Window  gWindow;
  GC      gGC;

  void GeneratePreview(Pixmap source);
  void Refresh();
  void SetDisplay(Widget parent, GC *gc, bool isFirst);

  Pane(Widget parent, bool isFirst, short newid, GC *gc, Pane *first, Pane *last, long w, long h);
  ~Pane();

};

#endif
