#ifndef STATE_H
#define STATE_H


#include "common.h"
#include "function.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


class State {

 public:
  static long  giHighestID;

  double       dXmin, dXmax, dYmin, dYmax;  /* Cartesian coordinates */
  long         lMaxIterations;              /* the number of iterations before we "give up"  */
  long         lWidth, lHeight;             /* dimensions of pixmap, drawing area */
  int          type;                        /* JULIA or MANDELBROT */
  Function     *function;
  short giFunctionIndex;

  long         id;

  State(char *filename);
  State(double xn, double xm, double yn, double ym, long w, long h, long i, short type, Function *f);
  ~State();

  void        Dump();
  static long GetID();
  void        Init();
  int         WriteToFile(char *filename);

};

#endif
