#include "xstate.h"

XState::XState(double xn, double xm, double yn, double ym, long w, long h, bool useColor, long i,
                short typ, Function *f)
  : State(xn, xm, yn, ym, w, h, i, typ, f)
{
  bUseColor = useColor;
  Init();
}



XState::XState(char *filename) : State(filename)
{
  Init();
}



XState::~XState(){

}


void XState::Init() {
  pane = 0;

  eyemap = 0;

  gpDisplay  = 0;
  gWindow    = 0;
  gpColormap = 0;
  gpGC       = 0;
  gpScreen   = 0;
  iScreenDepth    = 0;

}


void XState::SetupX(Widget toplevel, Colormap *cmap, GC *gc, EyeMap *cols) {

  gpDisplay       = XtDisplay(toplevel);
  gWindow         = XtWindow(toplevel);
  gpColormap      = cmap;
  gpGC            = gc;
  gpScreen        = XtScreen(toplevel);
  iScreenDepth    = DefaultDepthOfScreen(gpScreen);

  eyemap = new EyeMap(gpDisplay, gpColormap, cols->colors);

  pix = XCreatePixmap(gpDisplay, gWindow, lWidth, lHeight, iScreenDepth);
  
  XSetForeground(gpDisplay, (*gpGC), 0);
  XFillRectangle(gpDisplay, pix, (*gpGC), 0, 0, lWidth, lHeight);

}


int XState::WriteToFile(char *filename) {

    FILE   *fd;
    short  i;
    
    if ((fd = fopen(filename, "w")) == NULL) {
        printf("ERROR: %s could not be opened for writing\n", filename);
        return -1;
    }

    fprintf(fd, "%.15f %.15f %.15f %.15f", dXmin, dXmax, dYmin, dYmax);

    fprintf(fd, " %d", function->iFunctionIndex);

    if (type == JULIA)
        fprintf(fd, " %.15f %.15f", function->parameter.a, function->parameter.b);

    fprintf(fd, " %ld %ld %ld %d\n", lMaxIterations, lWidth, lHeight, bUseColor);

    for (i=0; i<NUM_COLORS; i++){
        fprintf(fd, "%d %d %d\n", eyemap->colors[i].red, eyemap->colors[i].green, eyemap->colors[i].blue);
    }

    fclose(fd);

    return 0;
}
