#ifndef XSTATE_H
#define XSTATE_H

#include "common.h"
#include "state.h"
#include "pane.h"
#include "eyemap.h"

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>

class XState : public State {

 public:
  XState *prev, *next;

  Pixmap        pix;                         /* the picture of the state */
  Pane         *pane;

  bool          bUseColor;
  EyeMap       *eyemap;

  Display  *gpDisplay;
  Window    gWindow;
  Colormap *gpColormap;
  GC       *gpGC;
  Screen   *gpScreen;
  int       iScreenDepth;

  XState(char *filename);
  XState(double xn, double xm, double yn, double ym, long w, long h, bool useColor, long i,
	 short type, Function *f);
  ~XState();

  void Init();
  void SetupX(Widget toplevel, Colormap *cmap, GC *gc, EyeMap *cols);
  int  WriteToFile(char *filename);
};

#endif
